<?php
////////////////////////////////////////////////////////////////
//
// File:      FAST 3.2 (First Automatic Server for Trackmania)
// Web:       
// Date:      17.04.2008
// Author:    Gilles Masson
// Plugin:	  MCM
////////////////////////////////////////////////////////////////

registerPlugin('lb',98);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// init the database
function lbInit($event)
{ 

global $lb_sql, $lb_pinfos, $lb_ptables, $lb_ptcount, $lb_ptlast, $lb_plist, $lb_pindex, $lb_pldb, $lb_chdb, $lb_redb, $lb_ml_xml;

//manialinks
	$lb_ml_xml = '';
	
	manialinksAddAction('lb_ml_mm.prev');
	manialinksAddAction('lb_ml_mm.quit');
	manialinksAddAction('lb_ml_mm.next');

	manialinksAddId('lb_ml_mm');

 
//load the db system
 include ("./data/php-api/txt-db-api.php");
  $rootdb = new Database(ROOT_DATABASE);
// create dbs if neccessary
  if (!file_exists(DB_DIR . "players")) $rootdb->executeQuery("CREATE DATABASE players");
  if (!file_exists(DB_DIR . "records")) $rootdb->executeQuery("CREATE DATABASE records");
  if (!file_exists(DB_DIR . "challenges")) $rootdb->executeQuery("CREATE DATABASE challenges");
// activate dbs
	$lb_pldb = new Database("players");
	$lb_chdb = new Database("challenges");
	$lb_redb = new Database("records");


// load players from database
	$result = $lb_pldb->executeQuery("LIST TABLES");
	$lb_ptables = GetArray($result);

	print_r('Local-> Loading Players...this could take some time...'."\n");
	$lb_pinfos= array();
	$lb_plist= array();
	$lb_pindex = 0;
	foreach($lb_ptables as $table)
	{	
	 	$lb_pindex++;
	 	$current_ptable = $table['table'];
		$result=$lb_pldb->executeQuery("SELECT *
							    FROM $current_ptable");
								
		
		$data = GetArray($result);
		
			$lb_pinfos[$data[0]['Login']] = $data[0]['Login'];
			$lb_pinfos[$data[0]['Login']] = array('PlayerId' => $data[0]['PlayerId'],
												 'Login' => $data[0]['Login'],
												 'NickName' => $data[0]['NickName'],
												 'Nation' => $data[0]['Nation'],
												 'Wins' => $data[0]['Wins'],
												 'Score' => $data[0]['Score'],
												 'TimePlayed' => $data[0]['TimePlayed'],
												 'LastSeen' => $data[0]['LastSeen'],
												 'PlayerPowers' => $data[0]['PlayerPowers'],
												 'ShowRecs' => $data[0]['ShowRecs'],
												 'ShowInfo' => $data[0]['ShowInfo']);

			array_push($lb_plist, $data[0]['Login']);
			//$lb_pindex = $data[0]['PlayerId'];
		
	}
	print_r('Local-> Done !!'."\n");

						
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// add the commands
registerCommand('add','/add tmxid : adds a track from TMX');
registerCommand('list','/list : a list of all challenges(text, time, time1 time2, nofinish)');
registerCommand('jbx','/jbx id : play next track with id, /jbx undo : remove your track from juke');
registerCommand('jukebox','/jukebox id : play next track with id');
registerCommand('recs','/recs : shows top 5 in chat can be /recs all');
registerCommand('karma','/karma : shows current track karma');
registerCommand('res','/res : starts a restart vote');
registerCommand('next','/next : starts a next vote'); 
registerCommand('kick','/kick login : starts a kick vote for specified login');
registerCommand('ban','/ban login : starts a ban vote for sepcified login');
registerCommand('y', '/y or y : vote for current voting with yes');
registerCommand('n', '/n or n : vote for current voting with no');
registerCommand('showrecs','/showrecs : enable or disable diplaying the local records');
registerCommand('showinfo', '/showinfo : enable or disable diplaying the info messages');
registerCommand('wins', '/wins : shows how often you have won');
registerCommand('rank','/rank : shows your current server rank');
registerCommand('pb','/pb : shows your personal best time on this track');
registerCommand('top','/top : shows current server ladder');
registerCommand('tmx','/tmx help : for help');
registerCommand('++','/++ : vote karma plus');
registerCommand('--','/-- : vote karma minus');
// add the admin comands
registerCommand('rem','/rem id : removes challengeid - take /list for ids',true);
registerCommand('del','/del id : deletes challengeid - take /list for ids',true);
registerCommand('dos', '/dos dir, cd number, cd .., add number : browse through trackdirectory',true);
registerCommand('ltut', '/ltut : enables or disables the little tutorial, /ltut number = frequency',true);
registerCommand('c','/c : cancel the current vote',true);
registerCommand('autotime', '/autotime on/off, min, max, multi : control the autotime',true);
registerCommand('votelimit', '/votelimit on/off or maxnext number or maxres number',true);
registerCommand('atm', '/atm on/off, votes number, ratio number',true);
registerCommand('joinmsg', '/joinmsg on/off enable or disable welcome message with server rank',true);
registerCommand('save', '/save cfg name [map name] : saves plugin config or tracklist to file name',true);
registerCommand('load', '/load cfg name [map name] : load plugin config or tracklist from file name',true);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////
//** init multimessage **//
///////////////////////////
global $lb_msgs, $lb_pagecount, $lb_maxpagecount, $lb_is_vote, $lb_is_list, $lb_vote_result_yes,
		 $lb_vote_result_no, $lb_allvoted, $lb_vote_result, $lb_vote_ratio, $lb_col1, $lb_col2, $_TracksDirectory;
$lb_msgs = array();
$lb_pagecount = array();
$lb_maxpagecount = array();
$lb_vote_result_yes = 0;
$lb_vote_result_no = 0;
$lb_vote_result = 0;
$lb_allvoted = 0;
$lb_is_vote = 0;
$lb_is_list = 0;
$lb_col1 = '$z$i$ff9';
$lb_col2 = '$z$i$cff';
 
/////////////////////////////
//** init jukebox **/////////
/////////////////////////////
global $lb_jbx, $lb_jbxnames, $lb_jbxmax, $lb_jbxbuffer, $lb_jbxbuffersize, $lb_autotime, 
		$lb_jbxlogin, $lb_jbxuid, $lb_jbx_tmx;

$lb_jbx = array();
$lb_jbxnames = array();
$lb_jbxlogin = array();
$lb_jbxuid = array();
$lb_jbx_tmx = array();
$lb_jbxmax = 7;
$lb_jbxbuffer = array('firstid');
$lb_jbxbuffersize = 10;
$lb_autotime = 1;
/////////////////////////////
//** init tmx directory **///
/////////////////////////////
$fast_tmx_directory = $_TracksDirectory.'Challenges/Downloaded/_FastTMX/';
if(!is_dir($fast_tmx_directory))
{
	mkdir($fast_tmx_directory, 0700);
}


///////////////////////////////////////
//** init server records and karma **//
///////////////////////////////////////

global $lb_maxtop, $lb_oldranking, $lb_votings, $lb_generalvote, $lb_joinmsg, $lb_update_ranking_logins;

$lb_maxtop = 250;
$lb_oldranking = 0;
$lb_votings = array();
$lb_generalvote = array();
$lb_joinmsg = 0;
$lb_update_ranking_logins = array(); 
////////////////////////
//** init votelimit **//
////////////////////////

global $lb_is_vote, $lb_col1, $lb_col2, $lb_maxnext, $lb_maxres, $lb_defmaxres, $lb_defmaxnext, $lb_time_disable,
		$lb_votelimit, $lb_vote_ratio, $lb_tmx_vote_ratio, $lb_dos_directory, $lb_show_directory, $lb_dirdeep,
		$lb_atm, $lb_autotime_min, $lb_autotime_max, $lb_autotime_multi, $lb_tmxadd;

$lb_col1 = '$z$i$ff9';
$lb_col2 = '$z$i$cff';
$lb_votelimit = array('status' => 1,'maxres' => 2,'maxnext' => 1,'ratio' => 0.6, 'tmxratio' => 0.3);
$lb_atm = array('status' => 1, 'votes' => 18, 'ratio' => 65);
$lb_is_vote = 0;
$lb_maxres = $lb_votelimit['maxres'];
$lb_maxnext = $lb_votelimit['maxnext'];
$lb_time_disable = 0;
$lb_vote_ratio = $lb_votelimit['ratio'];
$lb_tmx_vote_ratio = $lb_votelimit['tmxratio'];
$lb_dos_directory = $_TracksDirectory . 'challenges/';
$lb_show_directory[0] = 'challenges';
$lb_dirdeep = 0;
$lb_autotime_min = 270000;
$lb_autotime_max = 450000;
$lb_autotime_multi = 8;
$lb_tmxadd = 'admin';

////////////////////////////
//** init infomessages **///
////////////////////////////
global $lb_message_trigger, $lb_def_message_trigger, $lb_little_tut, $lb_def_message_counter;
$lb_little_tut = 0;
$lb_def_message_trigger = 2;
$lb_message_trigger = 1;
$lb_def_message_counter = 0;

// ** LOAD DEFAULT VALUES ** //
lb_load_config('default');

settype($lb_vote_ratio,"double");
settype($lb_tmx_vote_ratio,"double");
settype($lb_atm['votes'],"int");
settype($lb_votelimit['ratio'],"double");
settype($lb_votelimit['tmxratio'],"double");
}
// ** END INIT ** //



// ** LOAD SAVED CONFIG VALUES ** //
function lb_load_config($cfgfile)
{	global $lb_joinmsg, $lb_votelimit, $lb_atm, $lb_maxres, $lb_maxnext, $lb_autotime_min, $lb_autotime_max, $lb_autotime_multi, $lb_tmxadd,
		   $lb_message_trigger, $lb_def_message_trigger, $lb_little_tut, $lb_def_message_counter, $lb_autotime;
		   
	$configfile = './data/'.$cfgfile.'.lb.cfg.xml';
	if(file_exists($configfile))
	{
			$config = xml_parse_file($configfile);
	
			$lb_joinmsg = $config['LocalBaseSettings']['general']['lb_joinmsg'];
		 	$lb_atm = $config['LocalBaseSettings']['general']['lb_atm'];
		 	$lb_maxres = $config['LocalBaseSettings']['general']['lb_maxres'];
		 	$lb_maxnext = $config['LocalBaseSettings']['general']['lb_maxnext'];
		 	$lb_votelimit = $config['LocalBaseSettings']['general']['lb_votelimit'];
		 	$lb_autotime = $config['LocalBaseSettings']['general']['lb_autotime'];
		 	$lb_autotime_min = $config['LocalBaseSettings']['general']['lb_autotime_min'];
		 	$lb_autotime_max = $config['LocalBaseSettings']['general']['lb_autotime_max'];
		 	$lb_autotime_multi = $config['LocalBaseSettings']['general']['lb_autotime_multi'];
		 	$lb_tmxadd = $config['LocalBaseSettings']['general']['lb_tmxadd'];
			$lb_message_trigger = $config['LocalBaseSettings']['general']['lb_message_trigger'];
			$lb_def_message_trigger = $config['LocalBaseSettings']['general']['lb_def_message_trigger'];
			$lb_little_tut = $config['LocalBaseSettings']['general']['lb_little_tut'];
			$lb_def_message_counter = $config['LocalBaseSettings']['general']['lb_def_message_counter'];
			
			settype($lb_vote_ratio,"double");
			settype($lb_tmx_vote_ratio,"double");
			settype($lb_atm['votes'],"int");
			settype($lb_votelimit['ratio'],"double");
			settype($lb_votelimit['tmxratio'],"double");
			return(1);
	}
	else
	{
		if($cfgfile == 'default') 
		{
		 lb_save_config('default');
		 return;
		}
			return(0);
	}
}

// ** SAVE CONFIGURATION TO FILE ** //
function lb_save_config($cfgfile)
{	global $lb_joinmsg, $lb_votelimit, $lb_atm, $lb_maxres, $lb_maxnext, $lb_autotime_min, $lb_autotime_max, $lb_autotime_multi, $lb_tmxadd,
		   $lb_message_trigger, $lb_def_message_trigger, $lb_little_tut, $lb_def_message_counter, $lb_autotime;

			$config['LocalBaseSettings']['general']['lb_joinmsg'] = $lb_joinmsg;
		 	$config['LocalBaseSettings']['general']['lb_atm'] = $lb_atm;
		 	$config['LocalBaseSettings']['general']['lb_maxres'] = $lb_maxres;
		 	$config['LocalBaseSettings']['general']['lb_maxnext'] = $lb_maxnext;
		 	$config['LocalBaseSettings']['general']['lb_votelimit'] = $lb_votelimit;
		 	$config['LocalBaseSettings']['general']['lb_autotime'] = $lb_autotime;
		 	$config['LocalBaseSettings']['general']['lb_autotime_min'] = $lb_autotime_min;
		 	$config['LocalBaseSettings']['general']['lb_autotime_max'] = $lb_autotime_max;
		 	$config['LocalBaseSettings']['general']['lb_autotime_multi'] = $lb_autotime_multi;
		 	$config['LocalBaseSettings']['general']['lb_tmxadd'] = $lb_tmxadd;
			$config['LocalBaseSettings']['general']['lb_message_trigger'] = $lb_message_trigger;
			$config['LocalBaseSettings']['general']['lb_def_message_trigger'] = $lb_def_message_trigger;
			$config['LocalBaseSettings']['general']['lb_little_tut'] = $lb_little_tut;
			$config['LocalBaseSettings']['general']['lb_def_message_counter'] = $lb_def_message_counter;	 	
			
			$configfile = './data/'.$cfgfile.'.lb.cfg.xml';
			xml_build_to_file($config,$configfile);
}

function sqlesc($string)
{
	$string = str_replace('"','\"',$string);
	$string = str_replace('\\','\\\\',$string);
	$string = str_replace('\'','\\\'',$string);
	return($string);
}

function GetArray($resultset)
{
	$result = array();
	while($resultset->next())
	{
		$data = $resultset->getCurrentValuesAsHash();
		array_push($result, $data);
	}
	return($result);
}

function search_lb_pinfos($login)
{	global $lb_pinfos;

	foreach($lb_pinfos as $player)
	{
		if($player['Login'] == $login)
		{
			return($player);
		}
	}
	
	return(0);
	
}

function update_lb_pinfos($login,$score)
{	global $lb_pinfos;

	$player = search_lb_pinfos($login);
	$index = $player['PlayerId']-1;
	$lb_pinfos[$index]['Score'] = $score;
}

function chat_y($author,$login,$params)
{
	karma_vote($login, 'y');
	
}

function chat_n($author,$login,$params)
{
	karma_vote($login, 'n');
	
}
function chat_autotime($author,$login,$params)
{	global $lb_autotime, $lb_autotime_min, $lb_autotime_max, $lb_autotime_multi;

	if(!verifyAdmin($login)) return;
	
	if(!isset($params[0]))
	{	
	 	if($lb_autotime == 1) $status = 'ON';
	 	else $status = 'OFF';
		$message = '$z$i$000>> Autotime-Status is $f00'.$status.' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		$message = '$z$i$000>> Autotime-Min is $f00'.$lb_autotime_min.' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		$message = '$z$i$000>> Autotime-Max is $f00'.$lb_autotime_max.' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		$message = '$z$i$000>> Autotime-Multi is $f00'.$lb_autotime_multi.' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		return;	
	}
	
	if($params[0] == 'on')
	{
		$lb_autotime = 1;
		$message = '$z$i$000>> Autotime is now $f00ON !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		addCall(null,"SetTimeAttackLimit",320000);
	}
	elseif($params[0] == 'off')
	{
		$lb_autotime = 0;
		$message = '$z$i$000>> Autotime is now $f00OFF !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		$message = '$z$i$000>> Timeattacklimit is now $f0010min !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		addCall(null,"SetTimeAttackLimit",600000);
	}
	elseif($params[0] == 'max' && isset($params[1]) && is_numeric($params[1]))
	{
		$lb_autotime_max = $params[1];
		$message = '$z$i$000>> Autotime-Max is now $f00'.$params[1].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
	}
	elseif($params[0] == 'min' && isset($params[1]) && is_numeric($params[1]))
	{
		$lb_autotime_min = $params[1];
		$message = '$z$i$000>> Autotime-Min is now $f00'.$params[1].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
	}
	elseif($params[0] == 'multi' && isset($params[1]) && is_numeric($params[1]))
	{
		$lb_autotime_multi = $params[1];
		$message = '$z$i$000>> Autotime-Multi is now $f00'.$params[1].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
	}
}

function chat_ltut($author,$login,$params)
{	global $lb_little_tut, $lb_def_message_trigger;

	if(verifyAdmin($login))
	{
		if(!isset($params[0]))
		{
		if($lb_little_tut == 1)
			{
				$lb_little_tut = 0;
				$message = '$z$i$000>> Little tutorial is now $f00OFF !!$z';
				addCall(null,"ChatSendServerMessageToLogin", $message, $login);
				return;
			}
		if($lb_little_tut == 0)
			{
				$lb_little_tut = 1;
				$message = '$z$i$000>> Little tutorial is now $f00ON !!$z';
				addCall(null,"ChatSendServerMessageToLogin", $message, $login);
				return;
			}
		}
		
		if(isset($params[0]) && is_numeric($params[0]) && $params[0] > 0)
		{
			$lb_def_message_trigger = $params[0];
			$message = '$z$i$000>> Little tutorial will show every $f00'.$lb_def_message_trigger.' $z$i$000 tracks!';
			addCall(null,"ChatSendServerMessageToLogin", $message, $login);
			return;
		}
		
		
	}
	
}

function chat_c($author,$login,$params)
{	global $lb_is_vote;

	if(verifyAdmin($login))
	{
	addCall(null,"CancelVote");
	$message = '$z$i$fff>> Admin voted $f00NO$z';
		addCall(null,"ChatSendServerMessage", $message);
		$lb_is_vote = 0;
		addCall(null,"SendHideServerMessage");		
	}
	
	
}
/////////////////////////////
//** functions votelimit **//
/////////////////////////////
function chat_res($author, $login, $params)
{	global $lb_vote_reason, $lb_is_vote, $lb_maxres, $current_voting_message, $restart_time, $lb_votelimit,
			$_ServerOptions, $lb_tracktorestart, $_ChallengeInfo, $_PlayerList, $_players;

	$tmp_timeout=$_ServerOptions['CurrentCallVoteTimeOut'] /1000;
	$tmp_time = time();
	if($tmp_time <= $restart_time)	
	{
		$message = '$z$i$900>> Please wait $fff'.$tmp_timeout.'sec. $900 til end to restart !!';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		return;
	}
	
	if($lb_maxres > 0)
	{
	 		if($lb_is_vote == 1)
			{
			$message = '$z$i$900>> There is a vote running, wait til its over !!$z';
			addCall(null,"ChatSendServerMessageToLogin", $message, $login);
			addCall(null,"ChatSendServerMessageToLogin", $current_voting_message, $login);
			return;
			}
	$nick=$author;
	$lb_is_vote = 1;
	$lb_vote_reason = 'restart';
	$smalnick=stripEnlarge($nick);
	$smalnick=str_replace(' ','',$smalnick);

	$msg = '$i'.$smalnick.'$z$i$fff wants to $w$f00RESTART $z$i$fffthis challenge !! $z';
	$current_voting_message = '$i'.$smalnick.' $fff>> $z$i$w$f00RESTART  $z';
	//addCall(null,"SendDisplayServerMessage", $msg , 'Yes','No',0);
	addCall(null,"ChatSendServerMessage", $msg);
	if(count($_players > 2) && $lb_votelimit['status'] == 1)	$lb_maxres--;
	$lb_tracktorestart = $_ChallengeInfo['UId'];

	addCall(null,"SetCallVoteRatio", $lb_votelimit['ratio']);
		
	$string = array();
	$request = new IXR_Request('ChallengeRestart',$string);
		$xmla = $request->getXml();
		addCall(null,'CallVote', $xmla);

	}
	$message = '$z$i$900>> There are $fff'.$lb_maxres. ' $900restartvotes left ! $z';
	addCall(null,"ChatSendServerMessageToLogin", $message, $login);
	
}

function chat_next($author, $login, $params)
{	global $lb_jbx, $_ChallengeList,$_CurrentChallengeIndex, $lb_jbxnames, 
			$lb_jbxbuffer, $lb_vote_reason, $lb_is_vote, $lb_maxnext, $lb_defmaxnext, $lb_votelimit, 
			$lb_defmaxnext, $current_voting_message, $is_next, $lb_time_disable, $_ServerOptions;
	
	
	if($lb_maxnext == 0)
	{
		$message = '$z$i$900>> There are no more nextvotes left !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		return;
	}
	
		if($lb_is_vote == 1)
	{
		$message = '$z$i$900>> There is a vote running, wait til its over !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		addCall(null,"ChatSendServerMessageToLogin", $current_voting_message, $login);
		return;
	}
	if($lb_maxnext >0)
	{
	
	$nick=$author;
	$lb_is_vote = 1;
	$time_current = time();
	//print_r($time_current);
	//print_r("\n");
	$lb_time_disable = $time_current + ($_ServerOptions['CurrentCallVoteTimeOut']/1000) + 1 ;
//	print_r($lb_time_disable);
	$lb_vote_reason = 'next';
	$smalnick=stripEnlarge($nick);
	$smalnick=str_replace(' ','',$smalnick);

	$msg = '$i'.$smalnick.'$z$i$fff asks go to $w$f00NEXT $z$i$fff challenge !! $z';
	$current_voting_message = '$i'.$smalnick.' $fff>> $i$w$f00NEXT  $z';
	//	addCall(null,"SendDisplayServerMessage", $msg , 'Yes','No',0);
		addCall(null,"ChatSendServerMessage", $msg);
	if($lb_votelimit['status'] == 1 ) $lb_maxnext--;
	}
	$message = '$z$i$900>> There are $fff'.$lb_maxnext. ' $900nextvotes left ! $z';
	addCall(null,"ChatSendServerMessageToLogin", $message, $login);
///checkpoint1
	$string = array();
	$request = new IXR_Request('NextChallenge',$string);
		$xmla = $request->getXml();
		addCall(null,"SetCallVoteRatio", $lb_votelimit['ratio']);
		addCall(null,'CallVote', $xmla);

}

function chat_kick($author, $login, $params)
{	global $lb_vote_reason, $lb_is_vote, $_PlayerList, $kicklogin, $current_voting_message, $lb_votelimit,
			$_ServerOptions, $lb_time_disable;


	if(!isset($params[0])) return;
	$kicklogin = '';

	foreach($_PlayerList as $player)
			{
			 if ($player['Login'] == $params[0]) 
				{$kicknick = $player['NickName']; 
				 $kicklogin  = $player['Login'];
				 break;
				}
			}
	if($kicklogin == '')
		{
		$msg = '$z$i$fff Please check the login !! $z';
		addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
		return;
		}
	
		if($lb_is_vote == 1)
	{
		$message = '$z$i$900>> There is a vote running, wait til its over !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		addCall(null,"ChatSendServerMessageToLogin", $current_voting_message, $login);
		return;
	}
	
	$nick=$author;
	$lb_is_vote = 1;
	$time_current = time();
	$lb_time_disable = $time_current + ($_ServerOptions['CurrentCallVoteTimeOut']/1000) + 1;
	$lb_vote_reason = 'kick';
	$smalnick=stripEnlarge($nick);
	$smalnick=str_replace(' ','',$smalnick);
	
	$msg = '$i'.$smalnick.'$z$i$fff wants to $w$f00KICK $z$i$fff'.$kicknick.'!! $z';
	$current_voting_message = '$i'.$smalnick.'$w$f00 KICK $z$i$fff'.$kicknick.'!! $z';
//	addCall(null,"SendDisplayServerMessage", $msg , 'Yes','No',0);
		addCall(null,"ChatSendServerMessage", $msg);
		
		$string = array($kicklogin);
		$request = new IXR_Request('Kick',$string);
		$xmla = $request->getXml();
		addCall(null,"SetCallVoteRatio", $lb_votelimit['ratio']);
		addCall(null,'CallVote', $xmla);
}

function chat_ban($author, $login, $params)
{	global $lb_vote_reason, $lb_is_vote, $_PlayerList, $banlogin, $_PlayerList, $current_voting_message, 
			$_ServerOptions, $lb_time_disable, $lb_votelimit;
	
	if(!isset($params[0])) return;
	$banlogin = '';
	
	foreach($_PlayerList as $player)
			{ if ($player['Login'] == $params[0]) 
				{$bannick = $player['NickName']; 
				 $banlogin  = $player['Login'];
				 break;
				}
			}
	
	if($banlogin == '')
		{
		$msg = '$z$i$fff Please check the login !! $z';
		addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
		return;
		}
	
		if($lb_is_vote == 1)
	{
		$message = '$z$i$900>> There is a vote running, wait til its over !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		addCall(null,"ChatSendServerMessageToLogin", $current_voting_message, $login);
		return;
	}
	
	$nick=$author;
	$lb_is_vote = 1;
	$time_current = time();
	$lb_time_disable = $time_current + ($_ServerOptions['CurrentCallVoteTimeOut']/1000) +1 ;
	$lb_vote_reason = 'ban';
	$smalnick=stripEnlarge($nick);
	$smalnick=str_replace(' ','',$smalnick);
	
	$msg = '$i'.$smalnick.'$z$i$fff wants to $w$f00BAN $z$i$fff'.$bannick.'!! $z';
	$current_voting_message = '$i'.$smalnick.'$w$f00 BAN $z$i$fff'.$bannick.'!! $z';
//	addCall(null,"SendDisplayServerMessage", $msg , 'Yes','No',0);
	addCall(null,"ChatSendServerMessage", $msg);
		
		$string = array($banlogin);
		$request = new IXR_Request('Ban',$string);
		$xmla = $request->getXml();
		addCall(null,"SetCallVoteRatio", $lb_votelimit['ratio']);
		addCall(null,'CallVote', $xmla);
}

function next_by_voting()
{
	addCall(null,"NextChallenge");
}

function kick_by_voting()
{	global $kicklogin;
	addCall(null,"Kick", $kicklogin);
}

function ban_by_voting()
{	global $banlogin;

	addCall(null,"Ban", $banlogin);
}

function restart_by_voting()
{	global $_client, $lb_jbx, $_ChallengeList,$_CurrentChallengeIndex, $lb_jbxnames;
	
		$restartmap = $_ChallengeList[$_CurrentChallengeIndex]['FileName'];
		$restartmapname = $_ChallengeList[$_CurrentChallengeIndex]['Name'];
		array_unshift($lb_jbx, $restartmap);
		array_unshift($lb_jbxnames, $restartmapname);
}

//////////////////////////////////////////////
//** player connecting and disconnecting **///
//////////////////////////////////////////////
function player_local_connect($login)
{	global $_client, $_players, $lb_pinfos, $lb_ptables, $lb_ptlast, $lb_ptcount, $lb_pldb, $lb_plist, $lb_pindex;

	$player = $_players[$login];
	$newnick=$player['NickName'];
	$newnation = $player['Nation'];
	
	// initialize new player
	if(!in_array($login,$lb_plist))
	{
	$lb_pindex++;
	$nation = $player['Nation'];
	$playerid = $lb_pindex;
	//$tableid = floor($lb_pindex/300);
	$table = $lb_pindex;
	$file='players/'.$playerid.'.txt';
	//create new table if neccessary
	if (!file_exists(DB_DIR . $file)) 
	{
	$lb_pldb->executeQuery("CREATE TABLE $table (
 							PlayerId int DEFAULT '0',
				   			Login str DEFAULT '',
				   			NickName str DEFAULT '',
				   			Nation str DEFAULT '',
				   			Wins int DEFAULT '0',
				   			Score int DEFAULT '0',
				   			TimePlayed int DEFAULT '0',
				   			LastSeen str DEFFAULT '',
				   			PlayerPowers int DEFAULT '0',
				 			ShowRecs int DEFAULT '1',
				 			ShowInfo int DEFAULT '1')");
	}	
	//insert playerdata in file
	$dbnick = sqlesc($newnick);
	$lb_pldb->executeQuery("INSERT INTO $table
							VALUES
				    	  ('$playerid','$login','$dbnick','$nation','0','0','0',' ','0','1','1')");
	//insert playerdata in ram
	$lb_pinfos[$login] = array('PlayerId' => $playerid,
							   'Login' => $login,
							   'NickName' => $newnick,
							   'Nation' => $nation,
							   'Wins' => 0,
							   'Score' => 0,
							   'TimePlayed' => 0,
							   'LastSeen' => ' ',
							   'PlayerPowers' => 0,
							   'ShowRecs' => 1,
							   'ShowInfo' => 1);
							   
							  // 'Table' => $table);
	array_push($lb_plist, $login);
	$lb_pinfos[$login]['join'] = time();
	return;
	}
	$lb_pinfos[$login]['join'] = time();
	if($lb_pinfos[$login]['NickName'] != $newnick)
	{
	 $lb_pinfos[$login]['NickName'] = $newnick;
	 $dbnick = sqlesc($newnick);
	 $table = $lb_pinfos[$login]['PlayerId'];
	 $lb_pldb->executeQuery("UPDATE $table 
							 SET NickName = '$dbnick', Nation = '$newnation'
							 WHERE Login = '$login'");

	}
}

function player_local_disconnect($login)
{	global $_players, $lb_pldb, $lb_pinfos;

	$date = date("d.m.Y-H:i:s");
	$time_played = time()-$lb_pinfos[$login]['join'];

	$already_played = $lb_pinfos[$login]['TimePlayed'];
	$time_played = $already_played + $time_played;
	$lb_pinfos[$login]['TimePlayed'] = $time_played;
	$lb_pinfos[$login]['LastSeen'] = $date;
	$table = $lb_pinfos[$login]['PlayerId'];
	
	$lb_pldb->executeQuery("UPDATE $table
							SET TimePlayed='$time_played', LastSeen='$date'
							WHERE Login = '$login'");

}


// Player Finish updateing records for current track
function update_local_records($login, $tracktime)
{	global $lb_maxtop, $_PlayerList, $lb_col1, $lb_col2, $lb_redb, $_ChallengeInfo, $lb_pinfos;

	// in rounds mode time is 0 when not finished so dont update
	if($tracktime == 0) return;
	$recordfile = 'rec_'.$_ChallengeInfo['UId'];
    $uid = $_ChallengeInfo['UId'];


	$result=$lb_redb->executeQuery("SELECT *
									FROM $recordfile
									WHERE TrackUId = '$uid'
									AND PlayerLogin = '$login'");
	$data = GetArray($result);	
	// no record so put it in records
	if(!isset($data[0]))
		{	$date = date("d.m.Y-H:i:s");
			$lb_redb->executeQuery("INSERT INTO $recordfile
									VALUES
								   ('$uid','$login','$tracktime','$date','1','0')");		
			//show his trackrank if needed
			if($lb_pinfos[$login]['ShowRecs'] == 1)
			{	
			 $result2=$lb_redb->executeQuery("SELECT *
			 						 FROM $recordfile
									 WHERE PlayerTime > '0'	
									 ORDER BY PlayerTime ASC");
			 $data2=GetArray($result2);
			 $newrank = 0;
			 foreach($data2 as $rank)
			 {
				$newrank++;
				if($rank['PlayerLogin']== $login) 	break;	
			 }
			
			$msg = localeText(null,'record.top_prefix','Local ').
				   localeText(null,'record.top','$i you ',$newrank,MwTimeToString($tracktime));
	
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);		
			
			}
			return;
		}
// player has a record update it if current time better

	$date = date("d.m.Y-H:i:s");
	$tmp_playerfinish = $data[0]['PlayerFinish'];
	$playerfinish = $tmp_playerfinish + 1;
	if($data[0]['PlayerTime'] >= $tracktime  || $data[0]['PlayerTime'] == 0)
	{
	$lb_redb->executeQuery("UPDATE $recordfile
							SET PlayerTime='$tracktime', PlayerDate='$date', PlayerFinish='$playerfinish'
							WHERE PlayerLogin='$login'");
	$newrecord = 1;
	}
	else
	{
	$lb_redb->executeQuery("UPDATE $recordfile
							SET PlayerFinish='$playerfinish'
							WHERE PlayerLogin='$login'");
	$newrecord = 0;
	}
	
	if($newrecord == 0) return;
			//show to player if needed
			if($lb_pinfos[$login]['ShowRecs'] == 1)
			{
				$result=$lb_redb->executeQuery("SELECT *
			 						 			FROM $recordfile
			 						 			WHERE PlayerTime > '0'
									 			ORDER BY PlayerTime ASC");
			 	$data=GetArray($result);
	
			$newrank = 0;
			foreach($data as $rank)
			{
				$newrank++;
				if($rank['PlayerLogin']== $login)
				break;	
			}
		
				$msg = localeText(null,'record.top_prefix','Local ').
				   localeText(null,'record.top','$i you',$newrank,MwTimeToString($tracktime));
			
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);		
			}
} 
// endrace

function save_srecords($track)
{	global $lb_col1;


		$msg = localeText(null,'record.top_prefix','Local ');	
		dspsrecords(0, $msg, 3); // 0 shows record to all players 5 show top 5
			
}

// Race Begin
function manage_local_records($track)
{	global $lb_maxtop, $track_counter, $voteminus, $voteplus, $_players,
			$_GameInfos, $lb_votings, $lb_col1, $lb_col2, $_playerlistTime, $lb_redb, $lb_chdb, $_ChallengeInfo;
 	
 	//default values for new track
 	$recordfile = 'rec_'.$_ChallengeInfo['UId'];
 	$name = sqlesc($_ChallengeInfo['Name']);
 	$uid = $_ChallengeInfo['UId'];
 	$author = $_ChallengeInfo['AuthorTime'];
 	$copp = $_ChallengeInfo['CopperPrice'];
 	$count = 0;
 	$plus=0;
 	$minus=0;
 	$env = $_ChallengeInfo['Environnement'];
	$file = 'records/'.$recordfile.'.txt';
// check if track exists in database
	if(!file_exists(DB_DIR . 'challenges/'. $uid . '.txt'))
	{	$lb_chdb->executeQuery("CREATE TABLE $uid (
  			UId str DEFAULT '',
  			Name str DEFAULT '',
  			AuthorTime int DEFAULT '0',
  			CopperPrice int DEFAULT '0',
  			TrackCount int DEFAULT '0',
  			VotesPlus int DEFAULT '0',
			VotesMinus int DEFAULT '0',
			Env str DEFAULT '',
			Speci int DEFAULT '0')");
		
		$lb_chdb->executeQuery("INSERT INTO $uid
				VALUES
				('$uid','$name','$author','$copp','$count','$plus','$minus','$env','0')");	
		
		if(!file_exists(DB_DIR . $file))
		{
		$lb_redb->executeQuery("CREATE TABLE $recordfile (
								TrackUId str DEFAULT ' ',
								PlayerLogin str DEFAULT ' ',
								PlayerTime int DEFAULT '0',
								PlayerDate str DEFAULT ' ',
								PlayerFinish int DEFAULT '0',
								PlayerVote int DEFAULT '0')");
		}
	//load the challenge after creation
	}
	$result=$lb_chdb->executeQuery("SELECT *
									FROM $uid");
	$data=GetArray($result);
// is in database increase trackcounter    

if(isset($_players))
{	
	$trackcounter = $data[0]['TrackCount'];
	$trackcounter++;
	$lb_chdb->executeQuery("UPDATE $uid
							SET TrackCount='$trackcounter'");
}	
	$smaltrackname = stripEnlarge($_ChallengeInfo['Name']);
	$msg = localeText(null,'record.top_prefix','Local ').'$i Record is held by : ';
		   
	dspsrecords(' ',$msg,1);	
	check_karma(' ');
}

function dsptime($realtime)
{
	
	if ($realtime < 0) return 0;
	else
	{		
			$minutes = sprintf("%02s",floor($realtime/(1000*60)));
			$secondes = sprintf("%02s",floor(($realtime-$minutes*60*1000)/1000));
			$mseconds = substr($realtime,strlen($realtime)-3,2);
			return $minutes.":".$secondes.":".$mseconds;
	}
}

function dspsrecords($login, $prefix, $limit)
{	global $lb_redb, $lb_col1, $lb_col2, $_ChallengeInfo, $_PlayerList, $lb_pinfos;

$color = '$ff0';	
$color1 = '$cf9';
$color2 = '$cff';
$colordef = '$ff0';	
$color1def = '$cf9'; //'$bcd';
$color2def = '$cff'; //'$99b';
$colorgold = '$fc0';
$colorgold1 = '$fc0'; //'$fc6';
$colorsilver = '$fff';
$colorsilver1 = '$fff'; //'$ffc';
$colorbronze = '$630';
$colorbronze1 = '$630'; //'$633';

$uid=$_ChallengeInfo['UId'];
$recordfile='rec_'.$_ChallengeInfo['UId'];
if(!file_exists(DB_DIR.'records/'.$recordfile.'.txt')) return;
 	$result=$lb_redb->executeQuery("SELECT * FROM $recordfile
									WHERE PlayerTime > '0' ORDER BY PlayerTime ASC");								
 	$data=GetArray($result);

	if($login != ' ')
	{			
		$showtoplayer = $lb_pinfos[$login]['ShowRecs'];
		if($showtoplayer != 0 )
		{
			if(!isset($data[0]))
			{
			$msg = $prefix.$color2.' None.. $z';
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			return;
			}
		
		$records_count = count($data);
		
		if($records_count > $limit) 
		{$records_count = $limit;}
		
		$msg = $prefix;
		for($i = 0; $i < $records_count; $i++ )
		{
		$playerlogin = $data[$i]['PlayerLogin'];
		$nickname = $lb_pinfos[$playerlogin]['NickName'];
		$nickname = stripColors($nickname);
		$nickname = stripEnlarge($nickname);
		$index = $i+1;
		$msg .= $color.'$i$n'.$index.'. $z$n'.$color1.'$i'.$nickname.'$z'.$color2.'$i$n ['.MwTimeToString($data[$i]['PlayerTime']).'] $i$n';
		}
		addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
		return;
		}	
	}	
// show records to all 
		foreach($_PlayerList as $key)
		{
		$login = $key['Login'];
		$player = $lb_pinfos[$login];
		$showtoplayer = $player['ShowRecs'];
		if($showtoplayer != 0 )
		{
			if(!isset($data[0]))
			{
			$msg = $prefix.$color2.' No records yet.. $z';
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			}
			if(isset($data[0]))
			{	
			
			$records_count = count($data);
		
			if($records_count > $limit) 
			{$records_count = $limit;}
		
			$msg = $prefix;
			for($i = 0; $i < $records_count; $i++ )
			{
			$playerlogin = $data[$i]['PlayerLogin'];
			$nickdata = $lb_pinfos[$playerlogin];
			$nickname = $nickdata['NickName'];
		
			if($limit > 1)	$nickname = stripColors($nickname);
			$nickname = stripEnlarge($nickname);
			$nickname = '$i'.$nickname;
			$index = $i+1;
			if($limit > 1)
			{
			 if($index == 1){$color1 = $colorgold; $color2 = $colorgold1;}
			 elseif($index ==2){$color1 = $colorsilver; $color2 = $colorsilver1;}
			 elseif($index ==3){$color1 = $colorbronze; $color2 = $colorbronze1;}
			 elseif($index > 3){$color1 = $color1def; $color2 = $color2def;}
			 $msg .= $color.'$i$n'.$index.'. $z$n'.$color1.$nickname.'$z'.$color2.'$i$n ['.MwTimeToString($data[$i]['PlayerTime']).'] $i$n';
			}
			else
			{$msg .= '$i'.$nickname.'$z'.$color2.'$i ['.MwTimeToString($data[$i]['PlayerTime']).'] ';}
			}
		addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			}
		} //show to player yes or no	
	} //foreach active player			
} // end dspsrecords	

function check_karma($login)
{	global $current_track, $_ChallengeInfo, $lb_chdb;
	
	$lb_col1 = localeText(null,'interact');
	$lb_col2 = localeText(null,'highlight');
	$uid=$_ChallengeInfo['UId'];
	if(!file_exists(DB_DIR . 'challenges/'. $uid . '.txt')) return;
	$result=$lb_chdb->executeQuery("SELECT *
									FROM $uid");
	
	$data=GetArray($result);	
	if(isset($data[0]))
	{
	$votesplus = $data[0]['VotesPlus'];
	$votesminus = $data[0]['VotesMinus'];
	$trackcounter = $data[0]['TrackCount'];
	}
	else
	{
	$votesplus = 0;
	$votesminus = 0;
	$trackcounter = 1;
	}
	
	$allvotes = $votesplus + $votesminus;
	$karma = $votesplus - $votesminus;
	$approval = 0;
	
	if($votesplus != 0) $approval = $allvotes / $votesplus;	
	if($approval != 0) $approval = 100 / $approval;
	$approval = number_format($approval,2);
	
	$msg = $lb_col1.'Track Karma : '.$lb_col2.$karma.$lb_col1.' / Votes: '.$lb_col2.'-'.$votesminus.' +'.$votesplus;
	$msg .= $lb_col1.' ATM : '.$lb_col2.$approval.'% '.$lb_col1.'Played : '.$lb_col2.$trackcounter;
	
	if ($login == ' ' ) 
	{ 
	 addCall(null,"ChatSendServerMessage", $msg);
	 return;
	}
	if ($login == '1234' ) 
	{ 
	 $atm_result[0] = $approval;
	 $atm_result[1] = $allvotes;
	 $atm_result[2] = $votesminus;
	 return($atm_result);
	}
	
	
	addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
}

function karma_vote($login, $voting)
{	global $voteplus, $voteminus, $needed_votes_dsp, $lb_vote_reason,
			$lb_generalvote_result, $lb_generalvote, $lb_is_vote, $lb_time_disable, $_ChallengeInfo, $lb_redb, $lb_chdb;
	
	$lb_col1 = localeText(null,'interact');
	$lb_col2 = localeText(null,'highlight');
	$uid=$_ChallengeInfo['UId'];
	$recordfile='rec_'.$_ChallengeInfo['UId'];
	
	if($voting == '/--' || $voting == '/++') $voting = str_replace('/','',$voting);
				
	if($voting != '--' && $voting != '++' && $voting != 'y' && $voting != 'n' ) return;
	if($voting != '--' && $voting != '++' && $lb_time_disable > 0) return;

	if($voting == 'y' && $lb_is_vote == 1 && $lb_vote_reason == 'tmx')
	{
		if(in_array($login, $lb_generalvote))
		{
			$msg = $lb_col2.'You have already voted !';
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			return;
		}
		
		multi_message(0,$login,1);
		
			$msg = $lb_col1.'Thx for voting !! $z';
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			if($needed_votes_dsp > 0)
			{
			$msg = '$fff>>  '.$lb_col2.$needed_votes_dsp.$lb_col1.'  more vote(s) to pass!! $z ';
			addCall(null,"ChatSendServerMessage", $msg);
			array_unshift($lb_generalvote, $login);
			return;
			}
	}
	
	if($voting == 'n' && $lb_is_vote == 1 && $lb_vote_reason == 'tmx')
	{
		if(in_array($login, $lb_generalvote))
		{
			$msg = $lb_col2.'You have already voted !';
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			return;
		}
		
		multi_message(0,$login,2);
		$msg = $lb_col1.'Thx for Voting $z';
		addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
		array_unshift($lb_generalvote, $login);
		return;
		
	}
	
	if($voting == 'n' || $voting == 'y' && $lb_is_vote == 0)
	{
		//$msg = $lb_col1.'There is nothing to vote for :) $z';
		//addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
		return;
	}
	
	//breaking here if no -- or ++ vote
	if($voting != '--' && $voting != '++') return;
	
	if(!file_exists(DB_DIR.'records/'.$recordfile.'.txt')) return;
	$result=$lb_redb->executeQuery("SELECT *
									FROM $recordfile
									WHERE PlayerLogin = '$login'");	
	$votedata = GetArray($result);
	if(isset($votedata[0]))
	{
	  $playervote = $votedata[0]['PlayerVote'];
	}
	else
	{		
	 	$lb_redb->executeQuery("INSERT INTO $recordfile
		 						VALUES
								('$uid','$login','0',' ','0','0')");
	  $playervote = 0;
	}
		
	$result=$lb_chdb->executeQuery("SELECT *
									FROM $uid");

	$data=GetArray($result);
	$voteminus = $data[0]['VotesMinus'];
	$voteplus = $data[0]['VotesPlus'];
		
	if($playervote != 2 && $voting == '--')
		{
			$voteminus++;
			$msg = $lb_col2.'Vote sucsessfull !';
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			if($playervote != 0) $voteplus--;
			$lb_chdb->executeQuery("UPDATE $uid
									SET VotesPlus = '$voteplus', VotesMinus = '$voteminus'");
							
			$lb_redb->executeQuery("UPDATE $recordfile
									SET PlayerVote = '2'
									WHERE TrackUId = '$uid' AND PlayerLogin = '$login'");
			
			check_karma($login);
			return;
		}
		
	if($playervote != 1 && $voting == '++')
		{
			$voteplus++;
			$msg = $lb_col2.'Vote sucsessfull !';
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			if($playervote != 0) $voteminus--;
			$lb_chdb->executeQuery("UPDATE $uid
									SET VotesPlus = '$voteplus', VotesMinus = '$voteminus'");
							
			$lb_redb->executeQuery("UPDATE $recordfile
									SET PlayerVote = '1'
									WHERE TrackUId = '$uid' AND PlayerLogin = '$login'");
			
			check_karma($login);
			return;
		}  	
	$msg = $lb_col2.'You have already voted for this track !';
	addCall(null,"ChatSendServerMessageToLogin", $msg, $login);	
}

function chat_recs($author, $login, $params)
{	global $lb_maxpagecount, $lb_pagecount, $lb_is_list, $lb_maxtop, $lb_msgs, 
			$lb_col1, $_ChallengeInfo, $lb_redb, $lb_pinfos;

$col11 = '$z$i$0ff'; //'$z$i$93c';
$col2 = '$z$i$0f0'; //'$z$i$c0f';
//show all records in popub
$uid=$_ChallengeInfo['UId'];
$recordfile='rec_'.$uid;
if(!file_exists(DB_DIR.'records/'.$recordfile.'.txt')) return;
	if(!isset($params[0]))
		{
				$msg = localeText(null,'record.top_prefix','Local ');
				dspsrecords($login, $msg, 5); 	//show only top 5 in chat
				return;
		}
	
	if( $params[0] == 'all')
	{$maxline = 10;
	$page = 0;
	
	$lb_maxpagecount[$login] = 0;
	$lb_pagecount[$login] = 0;
	
	for ($i = 0; $i < 1600 ; $i++)
	{$lb_msgs[$login][$i] = ' ';} // clear previous message
	
	$result=$lb_redb->executeQuery("SELECT *
							 		FROM $recordfile
									WHERE PlayerTime > '0'
									ORDER BY PlayerTime ASC");
	$data=GetArray($result);
	if(!isset($data[0]))
			{
			$msg = $lb_col1.'No records yet.. $z';
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			return;
			}
	
	$counter = count($data);
	$recforpage = -1;
	
	 for($i=0; $i < $counter; $i++)
	 {		
			 $searchlogin = $data[$i]['PlayerLogin'];
			 if($searchlogin == $login) 
			 {
			  $recforpage = $i+1;
			  $searchnick = $lb_pinfos[$login]['NickName'];
			  break;
			  }
	}	
	
	$lb_msgs[$login][$page] = localeText(null,'server_message').'Current local records : '."\n";
		for($i=0; $i < $counter ;$i++)
			{
			 $index = $i+1;
			 $searchlogin = $data[$i]['PlayerLogin'];
			 $nickname=stripEnlarge($lb_pinfos[$searchlogin]['NickName']);	
			 
	$lb_msgs[$login][$page] .= $col11.$index.'.'.$col2.' ['.dsptime($data[$i]['PlayerTime']).$col2.'] $z$i '.$nickname."\n";
			$maxline--;
			if($maxline <= 0)
			{$maxline=10;
			if($recforpage >= 0)
			{
			$lb_msgs[$login][$page] .= "\n".localeText(null,'server_message').'Your Position :'."\n";
			$lb_msgs[$login][$page] .= $col11.$recforpage.'.'.$col2.
									' ['.dsptime($data[$recforpage-1]['PlayerTime']).
									$col2.'] $z$i '.$searchnick."\n";	
			}
			elseif($recforpage < 0)
			{
			$lb_msgs[$login][$page] .= localeText(null,'server_message')."\n";
			$lb_msgs[$login][$page] .= localeText(null,'server_message').'You have no record yet..'."\n";	
			}
			 $page++;
			 $lb_pagecount[$login]++;
			 $lb_maxpagecount[$login]++;
			 $lb_msgs[$login][$page] .= localeText(null,'server_message').'Current local records : '."\n";
			}
			}
	$lb_is_list = 1;
	multi_message($author, $login, 2);
	return;	
	}
}

function chat_karma($author, $login, $params)
{
	check_karma($login);
}


////////////////////////////////////
//** functions dos filehandling **//
////////////////////////////////////
function chat_dos($author, $login, $params)
{	global $_TracksDirectory, $lb_msgs, $lb_pagecount, $lb_maxpagecount, $lb_is_list, $lb_dos_directory,
		 $lb_show_directory, $lb_dirdeep;
	

	
	if(!verifyAdmin($login)) return;
	if(!isset($params[0])) return;
	
	$directory = $lb_dos_directory;
	
	if($params[0] == 'dir')
	{
	dosdir($author, $login);
	return;
	}

	if($params[0] == 'cd' && isset($params[1]) && is_numeric($params[1]))
	{	
	 	$index = $params[1]-1;
 		$files = scandir($directory,0);
 		$lb_dirdeep++;
		$lb_show_directory[$lb_dirdeep] = $files[$index];
		$tmp_directory = $lb_dos_directory.$lb_show_directory[$lb_dirdeep].'/';
			if(!is_dir($tmp_directory))
			{
			$message = '$z$i$fff>> The specified index is not a folder !!$z';
			addCall(null,"ChatSendServerMessageToLogin", $message, $login);
			$lb_dirdeep--;
			return;
			}
		$lb_dos_directory = $tmp_directory;
		dosdir($author, $login);
		return;	
	}
	
	if($params[0] == 'cd' && $params[1] == '..' )
	{	
	 	if($lb_dirdeep == 0)
 		{
 		$message = '$z$i$fff>> You are already in start trackfolder !!$z';
 		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
 		return;
 		}
	 
	 	$dircounter = strlen($lb_show_directory[$lb_dirdeep]) + 1;
	 	$dircounter = 0 - $dircounter;
		$lb_dos_directory = substr($lb_dos_directory, 0, $dircounter);
		$lb_dirdeep--;
		dosdir($author, $login);
		return;
	}
	
	if($params[0] == 'add' && is_numeric($params[1]))
	{
		$index = $params[1]-1;
 		$files = scandir($directory,0);
			if(is_dir($files[$index]))
			{
			$message = '$z$i$fff>> Can not add a folder !!$z';
			addCall(null,"ChatSendServerMessageToLogin", $message, $login);
			return;
			}
		
		dosadd($author,$index);
		return;	
	}
}

function dosdir($author, $login)
{	global $_TracksDirectory, $lb_msgs, $lb_pagecount, $lb_maxpagecount, $lb_is_list, $lb_dos_directory,
		 $lb_show_directory, $lb_dirdeep;	
		 
	$col_dir = '$z$i$f00>> $03f';
	$col_file = '$z';
	$col_index = '$z$000';
	
	$directory = $lb_dos_directory;
 
	$maxline = 10;
	$page = 0;
	
	$lb_maxpagecount[$login] = 0;
	$lb_pagecount[$login] = 0;
		
	for ($i = 0; $i < 1600 ; $i++)
	{$lb_msgs[$login][$i] = ' ';} // clear previous message
	
	$files = scandir($directory,0);
	$counter = count($files);
		
		$lb_msgs[$login][$page] = localeText(null,'server_message').'Objects in '.$lb_show_directory[$lb_dirdeep].': '."\n";
	for($index = 0 ; $index < $counter; $index++)
	{
		$ind = $index;
		$showindex = $index+1;
		
		if($files[$ind] != '.' && $files[$ind] != '..')
		{
		$filename = stripEnlarge($files[$ind]);
		$dirname = $filename;
		$filename = substr($filename, 0, -14);
		$filename = utf8_encode($filename);
		
		if(is_dir($lb_dos_directory.$files[$ind]))
		{
		$lb_msgs[$login][$page] .= $col_index.'['.$showindex.']'.$col_dir.'['.$dirname.']'."\n";	
		}
		else
		{
		$lb_msgs[$login][$page] .= $col_index.'['.$showindex.'] '.$col_file.$filename."\n";
		}
		
		$maxline--;
			if($maxline <= 0)
			{$maxline=10;
			 $page++;
			 $lb_pagecount[$login]++;
			 $lb_maxpagecount[$login]++;
			 $lb_msgs[$login][$page] .= localeText(null,'server_message').'Objects in '.$lb_show_directory[$lb_dirdeep].': '."\n";
			}
		}
	}
	$lb_is_list = 1;
	addCall(null,"SendHideServerMessageToLogin", $login);
	multi_message($author, $login, 2); 	
}

function dosadd($author, $index)
{	global $_TracksDirectory, $lb_dos_directory;
		
	$directory = $lb_dos_directory;
	$files = scandir($directory,0);

	$filename = $directory . '/' . $files[$index];
	addCall(null,"InsertChallenge",$filename);
	$trackname = stripEnlarge($files[$index]);
	$trackname = substr($trackname, 0, -14);
	$msg = $author.localeText(null,'server_message').' added challenge:  $fff'.$trackname;
	addCall(null,"ChatSendServerMessage", $msg);
	
	
}

function chat_rem($author, $author_login, $params)
{
	global $_ChallengeList;
	
	// verify if author is in admin list
	if(!verifyAdmin($author_login))
		return;
	
	// 
		if(isset($params[0]) && is_numeric($params[0]))
		{
		$filename = $_ChallengeList[$params[0] - 1]['FileName'];
		addCall(null,"RemoveChallenge",$filename);
		$trackname = $_ChallengeList[$params[0] - 1]['Name'];
		//$trackname = stripColors($trackname);
		$msg = $author.localeText(null,'server_message').' removed track : $fff'.$trackname.'$z';
		addCall(null,"ChatSendServerMessage", $msg);
		}
}

function chat_del($author, $author_login, $params)
{
	global $_ChallengeList, $_TracksDirectory, $_ChallengeInfo;
	
	// verify if author is in admin list
	if(!verifyAdmin($author_login))
		return;
	
	// 
		if(isset($params[0]) && is_numeric($params[0]))
		{
		$filename = $_ChallengeList[$params[0] - 1]['FileName'];
		$trackname = $_ChallengeList[$params[0] - 1]['Name'];
		addCall(null,"RemoveChallenge",$filename);
		$localfile = $_TracksDirectory . '/' . $filename;
		unlink($localfile); 
		$trackname = stripColors($trackname);
	
		$msg = $author.localeText(null,'server_message').' deleted track : $fff'.$trackname.'$z';
		addCall(null,"ChatSendServerMessage", $msg);
		}
		elseif(isset($params[0]) && $params[0] == 'it')
		{
		 $filename = $_ChallengeInfo['FileName'];
		 $trackname = $_ChallengeInfo['Name'];
		 addCall(null,"RemoveChallenge",$filename);
		$localfile = $_TracksDirectory . '/' . $filename;
		unlink($localfile); 
		$trackname = stripColors($trackname);
	
		$msg = $author.localeText(null,'server_message').' deleted track : $fff'.$trackname.'$z';
		addCall(null,"ChatSendServerMessage", $msg);
			
		}
}


/////////////////////////////
//** functions jukebox **////
/////////////////////////////
// maps list


function chat_list($author, $login, $params){
	global $_ChallengeList, $_ChallengeInfo, $lb_msgs, $lb_pagecount, $lb_maxpagecount, 
			$_client, $lb_is_list, $lb_redb, $lb_maxtop, $_Game;

	$maxline = 14;
	$page = 0;
	
	$lb_maxpagecount[$login] = 0;
	$lb_pagecount[$login] = 0;
	
	
	for ($i = 0; $i < 1600 ; $i++)
	{$lb_msgs[$login][$i] = ' ';} // clear previous message
	
	$clsize = count($_ChallengeList);
	
	//list all tracks
	if (!isset($params[0]))
	{
	$lb_msgs[$login][$page] = localeText(null,'server_message').'Challenges on this server: '."\n";
	for($index = 0 ; $index < $clsize; $index++)
	{
		$ind = $index;
		$showindex = $index+1;
	
		$lb_msgs[$login][$page] .= '$z$fff['.$showindex.'] >> '.stripEnlarge($_ChallengeList[$ind]['Name']);
		if($_Game == 'TMU')
		{
		$lb_msgs[$login][$page] .= '$z$fff - '.$_ChallengeList[$ind]['Environnement'];
		}
		$lb_msgs[$login][$page] .= "\n";
		$maxline--;
			if($maxline <= 0)
			{$maxline=10;
			 $page++;
			 $lb_pagecount[$login]++;
			 $lb_maxpagecount[$login]++;
			 $lb_msgs[$login][$page] .= localeText(null,'server_message').'Challenges on this server: '."\n";
			}
	}
	$lb_is_list = 1;
	multi_message($author, $login, 2);
	return;
	}

	if(isset($params[0]) && $params[0] == 'nofinish' || (isset($params[0]) && $params[0] == 'nf'))
	{
	$lb_msgs[$login][$page] = localeText(null,'server_message').'You have no record on : '."\n";
	
	for($index = 0 ; $index < $clsize; $index++)
	{
		$ind = $index;
		$showindex = $index+1;
		$recordfile= 'rec_'.$_ChallengeList[$index]['UId'];
		$filename = 'records/'.$recordfile.'.txt';
		if (file_exists(DB_DIR . $filename))
		{
		$result=$lb_redb->executeQuery("SELECT *
								FROM $recordfile
								WHERE PlayerLogin = '$login'");	
		$data = GetArray($result);
		}
		if(!isset($data[0]))
		{	
		$lb_msgs[$login][$page] .= '$z$000['.$showindex.'] >> '.stripEnlarge($_ChallengeList[$ind]['Name'])."\n";
		$maxline--;
			if($maxline <= 0)
			{$maxline=10;
			 $page++;
			 $lb_pagecount[$login]++;
			 $lb_maxpagecount[$login]++;
			 $lb_msgs[$login][$page] .= localeText(null,'server_message').'You have no record on : '."\n";
			}
		}
	}
	$lb_is_list = 1;
	multi_message($author, $login, 2);
	
	return;	
	}
//searching for top rankings
	if(isset($params[0]) && $params[0] == 'notop' || (isset($params[0]) && $params[0] == 'nt'))
	{
	 	if(!isset($params[1]))
	 	$top = $lb_maxtop;
	 	else
	 	{
			if(!is_numeric($params[1]) || $params[1] < 1) $top = $lb_maxtop;
			else
			$top = $params[1];
		}
	$result = searchpos($login, $top);	
	$clsize = count($result);
	$lb_msgs[$login][$page] = localeText(null,'server_message').'You are not in top '.$top.' : '."\n";
	for($index = 0 ; $index < $clsize; $index++)
	{
		$showindex = $result[$index]['chindex'] +1;
					
		$lb_msgs[$login][$page] .= '$z$000['.$showindex.'] >> '.$result[$index]['name'].'$z$f00 - '.$result[$index]['pos']."\n";
		$maxline--;
			if($maxline <= 0)
			{$maxline=10;
			 $page++;
			 $lb_pagecount[$login]++;
			 $lb_maxpagecount[$login]++;
			 $lb_msgs[$login][$page] .= localeText(null,'server_message').'You are not in top '.$top.' : '."\n";
			}
		
	}
	$lb_is_list = 1;
	multi_message($author, $login, 2);
	
	return;	
	}
// list with searchstring for author or trackname	
	if (isset($params[0]) && !is_numeric($params[0]))
	{
	$lb_msgs[$login][$page] = localeText(null,'server_message').'Challenges with : '.strtolower($params[0])."\n";
	for($index = 0 ; $index < $clsize; $index++)
	{
		$ind = $index;
		$showindex = $index+1;
		$filename = $_ChallengeList[$ind]['FileName'];
		
		$challengeinfo = $_client->query('GetChallengeInfo', $filename);
		$challengeinfo = $_client->GetResponse();
		$challengeauthor = $challengeinfo['Author'];
		
		if (strstr(strtolower(stripcolors($_ChallengeList[$ind]['Name'])),strtolower($params[0])) || strstr(strtolower($challengeauthor),strtolower($params[0])))
		{
		$lb_msgs[$login][$page] .= localeText(null,'server_message').'['.$showindex.'] >> $f00'.stripEnlarge($_ChallengeList[$ind]['Name'])."\n";
		$maxline--;
			if($maxline <= 0)
			{$maxline=10;
			 $page++;
			 $lb_pagecount[$login]++;
			 $lb_maxpagecount[$login]++;
			 $lb_msgs[$login][$page] = localeText(null,'server_message').'Challenges with : '.strtolower($params[0])."\n";
			}
		}
	}
		$lb_is_list = 1;
		multi_message($author, $login, 2);
	// send the 1. message to user who wrote command
	return;
	}
// list with searchstring for author time 
	if (isset($params[0]) && is_numeric($params[0]))
	{
	 if (!isset($params[1]))
		{
		$minauthortime = 0;
		$maxauthortime = $params[0];	
		}
		else
		{
		$minauthortime = $params[0];
		$maxauthortime = $params[1];
		}
	$lb_msgs[$login][$page] .= localeText(null,'server_message').'MinTime > '.$minauthortime.' : MaxTime > '.$maxauthortime."\n";
	for($index = 0 ; $index < $clsize; $index++)
	{
		$ind = $index;
		$showindex = $index+1;
		$filename = $_ChallengeList[$ind]['FileName'];
		
		$challengeinfo = $_client->query('GetChallengeInfo', $filename);
		$challengeinfo = $_client->GetResponse();
		$authortime = $challengeinfo['AuthorTime'];
		$authortime = $authortime / 1000;
		
		
		
		if ($authortime > $minauthortime && $authortime < $maxauthortime)
		{
		$lb_msgs[$login][$page] .= localeText(null,'server_message').'['.$showindex.'] >> $f00'.stripEnlarge($_ChallengeList[$ind]['Name'])."\n";
		$maxline--;
			if($maxline <= 0)
			{$maxline=10;
			 $page++;
			 $lb_pagecount[$login]++;
			 $lb_maxpagecount[$login]++;
			 $lb_msgs[$login][$page] .= localeText(null,'server_message').'MinTime > '.$minauthortime.' : MaxTime > '.$maxauthortime."\n";
			}
		}
	}
	
	//addCall(null,"SendDisplayServerMessageToLogin", $login, $lb_msgs[$login][0], 'Close','next',0);
		$lb_is_list = 1;
		multi_message($author, $login, 2);
	// send the 1. message to user who wrote command
	return;
	}
}

function searchpos_track($login)
{	global $_ChallengeInfo, $lb_redb;
$uid=$_ChallengeInfo['UId'];
$recordfile='rec_'.$uid;

	$result=$lb_redb->executeQuery("SELECT *
									FROM $recordfile
									WHERE PlayerTime > '0'
									ORDER BY PlayerTime ASC");
	
	$ranking=GetArray($result);
	if(!isset($ranking)) return(0);
	$rankcounter = count($ranking);
	$playerinfos = array();
		for($j = 0; $j < $rankcounter; $j++)
			{	
			  if($ranking[$j]['PlayerLogin'] == $login)
			  {
				$playerinfos['Position'] = $j+1;
				$playerinfos['Finished'] = $ranking[$j]['PlayerFinish'];
				return($playerinfos);	
			  }
			}
	
}

function searchpos($login, $top)
{	global $lb_redb, $lb_maxtop, $_ChallengeList;
	
	
	$resindex = 0;
	$chcount = count($_ChallengeList);
	$result = array();

	for($i = 0; $i < $chcount; $i++)
	{	
		$recordfile='rec_'.$_ChallengeList[$i]['UId'];
		$file = 'records/'.$recordfile.'.txt';
		$rankcounter = 0;
		if(file_exists(DB_DIR . $file))
		{
		$getresult=$lb_redb->executeQuery("SELECT *
								   		   FROM $recordfile
								   		   WHERE PlayerTime > '0'
								   		   ORDER BY PlayerTime ASC");
		$ranking=GetArray($getresult);
		$rankcounter = count($ranking);	
		}
			
		$trackname = stripEnlarge($_ChallengeList[$i]['Name']);
		$setnotop = 0;	
		
		if($rankcounter > 0)
		{
			$poscounter = 0;
			
			for($j = 0; $j < $rankcounter; $j++)
			{	
			  if($j < $top && $ranking[$j]['PlayerLogin'] == $login) 	
				{	
				 	$setnotop = 1;
					
				}
		 		if($j > $top-1 && $ranking[$j]['PlayerLogin'] == $login)
				{ 					
				$result[$resindex] = array(
			 						   'chindex' => $i,
				 					   'name' => $trackname,
									   'pos' => $j+1);
				$resindex++;
				$setnotop = 1;
				
				}	
		
			}
		}
		if($setnotop == 0)
		{
			$result[$resindex] = array('chindex' => $i,
				 					   'name' => $trackname,
									   'pos' => 'NF');
				$resindex++;
		}
	}
	return($result);		
}

function chat_jbx($author, $login, $params)
{	global $lb_jbx, $_ChallengeList, $lb_msgs, $lb_jbxnames, $lb_jbxmax, $lb_jbxbuffer, 
			$lb_jbxbuffersize, $lb_jbxlogin, $lb_jbxuid;

	$clsize = count($_ChallengeList);
	$jbxnames_count = count($lb_jbxnames);
	
		
// if no params is set, display the current jukebox list
	if (!isset($params[0])) 
	{ 
		if ($jbxnames_count > 0)
		{
			$msg = localeText(null,'server_prefix').localeText(null,'emotic').
				   ' Tracks in jukebox ';
			for ($i = 0 ; $i < $jbxnames_count; $i++)
			{
			$msg .= localeText(null,'emotic').' >> $fff'.stripColors($lb_jbxnames[$i]);
			}
		addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
		return;
		}	 
	$msg = localeText(null,'server_prefix').localeText(null,'emotic').
		   ' No tracks in jukebox $z';
	addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
	return;
	}
// the admin command /jbx clear
		if (isset($params[0]) && $params[0] == 'clear')
		{
			if(verifyAdmin($login))
			{
			$lb_jbx = array();
			$lb_jbxnames = array();
			$lb_jbxlogin = array();
			$lb_jbxuid = array();
			$msg = localeText(null,'server_prefix').localeText(null,'emotic').
				   ' you have cleared jukebox ! $z';
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			return;				
			}
//		$msg = '$z$i$f90>> Sorry only for admins ! $z';
//		addCall(null,"ChatSendServerMessageToLogin", $msg, $login);	
		return;
		}
// check for undo
		if(isset($params[0]) && $params[0] == 'undo')
		{
		 		if(!in_array($login,$lb_jbxlogin))
				{
					$msg = localeText(null,'server_prefix').localeText(null,'emotic').
		   			' You dont have a track in jukebox ! $z';
					addCall(null,"ChatSendServerMessageToLogin", $msg, $login);	
					return;
				}	
		$counter = count($lb_jbxlogin);
		$tmp_jbx=array(); $tmp_jbxnames=array(); $tmp_jbxlogin=array(); $tmp_jbxuid=array();
		for($j = 0; $j < $counter; $j++)
		{	
			if($lb_jbxlogin[$j] != $login)
			{
				array_push($tmp_jbx,$lb_jbx[$j]);
				array_push($tmp_jbxnames, $lb_jbxnames[$j]);
				array_push($tmp_jbxlogin, $lb_jbxlogin[$j]);
				array_push($tmp_jbxuid, $lb_jbxuid[$j]);
			}	
		}
				$lb_jbx = $tmp_jbx;
				$lb_jbxnames = $tmp_jbxnames;
				$lb_jbxlogin = $tmp_jbxlogin;
				$lb_jbxuid = $tmp_jbxuid;
				
		$msg = localeText(null,'server_prefix').localeText(null,'emotic').
		   	   ' Your track is removed from jukebox ! $z';
		addCall(null,"ChatSendServerMessageToLogin", $msg, $login);	
		return;
		}
	
// check if login has track in juke
	if(in_array($login,$lb_jbxlogin) && !verifyAdmin($login))
	{
	$msg = localeText(null,'server_prefix').localeText(null,'emotic').
		   ' You already have a track in jukebox ! $z';
	addCall(null,"ChatSendServerMessageToLogin", $msg, $login);	
	return;
	}
// check if jukebox is full
	if($jbxnames_count >= $lb_jbxmax && !verifyAdmin($login))
	{
	$msg = localeText(null,'server_prefix').localeText(null,'emotic').
		   ' Jukebox is full, better luck next time $z';
	addCall(null,"ChatSendServerMessageToLogin", $msg, $login);	
	return;
	}



// filling the jukebox	
		if (isset($params[0]) && $params[0] > 0 && $params[0] < ($clsize+1) && isset($lb_msgs[$login][0]))
		{
			// check if track has been played recently
			$trackuid = $_ChallengeList[$params[0]-1]['UId'];
			if(in_array($trackuid,$lb_jbxbuffer) && !verifyAdmin($login))
				{
				$msg = localeText(null,'server_prefix').localeText(null,'emotic').
					   ' Track has been played recently $z';
				addCall(null,"ChatSendServerMessageToLogin", $msg, $login);	
				return;
				}
		$filename = $_ChallengeList[$params[0]-1]['FileName'];
		$trackname = $_ChallengeList[$params[0]-1]['Name'];
		$jbxuid = $_ChallengeList[$params[0]-1]['UId'];
	
			if (in_array($filename, $lb_jbx))
			{
			$msg = localeText(null,'server_prefix').'$z$i$fff '. 
				   stripColors($_ChallengeList[$params[0]-1]['Name']).
				   localeText(null,'emotic').' already in jukebox !!$z';
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			return;
			}
	
		$msg = localeText(null,'server_prefix').'$z$i$fff '. stripColors($_ChallengeList[$params[0]-1]['Name']).
			   localeText(null,'emotic').' jukeboxed by $fff'.stripColors($author).'$z';
		addCall(null,"ChatSendServerMessage", $msg);
		array_push($lb_jbx, $filename);
		array_push($lb_jbxnames, $trackname);
		array_push($lb_jbxlogin, $login);
		array_push($lb_jbxuid, $jbxuid);
		return;
		}
		
	$msg = localeText(null,'highlight').'>> Get the challenges first with /list $z';
	addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
	
}

function check_jukebox($case)
{	global $lb_jbx, $_ChallengeList, $lb_jbxnames, $_CurrentChallengeIndex, $lb_jbxbuffer, $lb_jbxbuffersize, $_NextChallengeIndex, $lb_is_vote, $lb_autotime, $lb_jbxlogin, $lb_jbxuid, $_ChallengeInfo, $lb_autotime_min, $lb_autotime_max, $lb_autotime_multi;
			
	$lb_is_vote = 0;
	$timeset = 0;
	$tmp_jbx = array();
	$tmp_jbx = array_reverse($lb_jbx);
	$tmp_jbxnames = array();
	$tmp_jbxnames = array_reverse($lb_jbxnames);
	$tmp_jbxlogin = array();
	$tmp_jbxlogin = array_reverse($lb_jbxlogin);
	$tmp_jbxuid = array();
	$tmp_jbxuid = array_reverse($lb_jbxuid);
	
	$counter = count($_ChallengeList);

	if (isset($lb_jbxuid[0]) && $case == 2)
	{
		for ( $i = 0; $i < $counter ; $i++)
		{
			if($_ChallengeList[$i]['UId'] == $lb_jbxuid[0])
			{
			$msg = localeText(null,'server_prefix').'$z$i$fff'. stripColors($_ChallengeList[$i]['Name']).
				   localeText(null,'emotic').' is next track from jukebox $z';
			addCall(null,"ChatSendServerMessage", $msg);
			$lb_jbx[0]=$_ChallengeList[$i]['FileName'];
			
			$timelimit = $_ChallengeList[$i]['GoldTime'];
			$timelimit = $timelimit * $lb_autotime_multi;
			
				if($timelimit < $lb_autotime_min) $timelimit = $lb_autotime_min;
				if($timelimit > $lb_autotime_max) $timelimit = $lb_autotime_max;
				$timeset = 1;
			}		
		}
	
	
	addCall(null,"ChooseNextChallenge", $lb_jbx[0]);
	}
	//check for restart, do nutting with tracks in jbx
	if(isset($lb_jbx[0]) && $_ChallengeInfo['UId'] == $lb_jbxuid[0])
						{
	array_pop($tmp_jbx);
	array_pop($tmp_jbxnames);
	array_pop($tmp_jbxlogin);
	array_pop($tmp_jbxuid);
	$lb_jbx = array_reverse($tmp_jbx);
	$lb_jbxnames = array_reverse($tmp_jbxnames);
	$lb_jbxlogin = array_reverse($tmp_jbxlogin);
	$lb_jbxuid = array_reverse($tmp_jbxuid);
						}
	
	if(isset($lb_jbx[0]) && $_ChallengeInfo['UId'] == $lb_jbxuid[0])
							{
	if(count($lb_jbxbuffer) < $lb_jbxbuffersize) array_unshift($lb_jbxbuffer, $_ChallengeList[$_CurrentChallengeIndex]['UId']);
	if(count($lb_jbxbuffer) >= $lb_jbxbuffersize)
	{
		array_pop($lb_jbxbuffer);
		array_unshift($lb_jbxbuffer, $_ChallengeList[$_CurrentChallengeIndex]['UId']);		
	}
							}
	addCall(true,'GetNextChallengeIndex');
	
	if ($timeset == 0 && $case == 2)
	{
	$timelimit = $_ChallengeList[$_NextChallengeIndex]['GoldTime'];
	$timelimit = $timelimit * $lb_autotime_multi;
	if($timelimit < $lb_autotime_min) $timelimit = $lb_autotime_min;
	if($timelimit > $lb_autotime_max) $timelimit = $lb_autotime_max;
	}
	
	if($lb_autotime == 1 && $case == 2)
	{
	settype($timelimit, "int");
	addCall(null,"SetTimeAttackLimit",$timelimit);
	}
/*	
	if($case == 2 && in_array($_ChallengeInfo['UId'],$lb_jbx_tmx))
	{
		$key = array_search($_ChallengeInfo['UId']);
		$key = $key - 1;
		addCall(null,"RemoveChallenge", $lb_jbx_tmx[$key]);
		array_splice($lb_jbx_tmx,$key -1, $key);
		print_r($lb_jbx_tmx);
	}
*/
}

function chat_jukebox($author, $login, $params) { chat_jbx($author, $login, $params);}

 
/////////////////////////////
//** functions tmxadd **/////
/////////////////////////////
function tmx_download($login,$num) 
{ global $_TracksDirectory, $lb_xtrack, $_Game, $lb_tmx_local_file;
	
//	if($_Game == 'TMN') $tmxprefix = 'nations';
//	if($_Game == 'TMU') $tmxprefix = 'united';
$tmxprefix = 'tmnforever';	
	$lb_xtrack = array('File' => "", 'UId' => "", 'Name' => "", 'Author' => "",
					   'Envir' => "", 'Type' => "", 'ATime' => 0);
	
	$result=file_get_contents('http://'.$tmxprefix.'.tm-exchange.com/get.aspx?action=trackgbx&id='.$num);
	if ($result) {
		$tmp=strstr($result,'<ident');
		$tmp=strstr($tmp,'uid="');
		$tmp=substr($tmp,0,200);
		$tmp=str_replace('uid="','',$tmp);
		$stop=strpos($tmp,'"');
		if ($stop > 0) $lb_xtrack['UId']=substr($tmp,0,$stop);
	
		$tmp=strstr($result,'<ident');
		$tmp=strstr($tmp,'name="');
		$tmp=substr($tmp,0,200);
		$tmp=str_replace('name="','',$tmp);
		$stop=strpos($tmp,'"');
		if ($stop > 0) $lb_xtrack['Name'] = urldecode(substr($tmp,0,$stop));

		$tmp=strstr($result,'<ident');
		$tmp=strstr($tmp,'author="');
		$tmp=substr($tmp,0,40);
		$tmp=str_replace('author="','',$tmp);
		$stop=strpos($tmp,'"');
		if ($stop > 0) $lb_xtrack['Author'] = substr($tmp,0,$stop);
		
		$tmp=strstr($result,'<desc');
		$tmp=strstr($tmp,'envir="');
		$tmp=substr($tmp,0,40);
		$tmp=str_replace('envir="','',$tmp);
		$stop=strpos($tmp,'"');
		if ($stop > 0) $lb_xtrack['Envir'] = substr($tmp,0,$stop);
		
		$tmp=strstr($result,'<desc');
		$tmp=strstr($tmp,'type="');
		$tmp=substr($tmp,0,40);
		$tmp=str_replace('type="','',$tmp);
		$stop=strpos($tmp,'"');
		if ($stop > 0) $lb_xtrack['Type'] = substr($tmp,0,$stop);
	
		$tmp=strstr($result,'<desc');
		$tmp=strstr($tmp,'authortime="');
		$tmp=substr($tmp,0,40);
		$tmp=str_replace('authortime="','',$tmp);
		$stop=strpos($tmp,'"');
		if ($stop > 0) $lb_xtrack['ATime'] = substr($tmp,0,$stop);
	
		
		if($lb_xtrack['Name'] != "" && $lb_xtrack['Author'] != "") 
			{
		
			$lb_xtrack['File'] = $_TracksDirectory.'Challenges/Downloaded/_FastTMX/TMX-'.$num.
								 '-'.stripColors($lb_xtrack['Author']).'.Challenge.Gbx';
			
								 //'-'.stripColors($lb_xtrack['Name']).'.Challenge.Gbx';
			$lb_tmx_local_file = $result;
			//file_put_contents($lb_xtrack['File'],$result);
			return $lb_xtrack['File'];
			}
	}
	

		$msg = '$z$i$fff>> '.$num.'$z$i  $f90is not a challenge on tmx !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
		return "";

}


function chat_add($author, $login, $params)
{	global $_client, $lb_jbx, $_ChallengeList,$_CurrentChallengeIndex, $lb_jbxnames, $lb_jbxmax, 
			$lb_xtrack, $lb_jbxbuffer, $lb_is_vote, $lb_msgs, $lb_tmx_local_file, $lb_tmxadd,
			$_TracksDirectory, $current_voting_message, $lb_jbxlogin, $lb_jbxuid, $_ChallengeInfo;
	
	if(!verifyAdmin($login) && $lb_tmxadd == 'admin') 
	{
	$msg = '$z$i$fff>> $z$i  $fff Sorry here is add admin only !!$z';
	 addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
	 return;
	}

	if(!isset($params[0]))
	{ 
	 $msg = '$z$i$fff>> $z$i  $f90please include the tmx id !!$z';
	 addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
	 return;
	}
	
	if(!is_numeric($params[0]))
	{ 
	 $msg = '$z$i$fff>> $z$i  $f90the tmxid should be a number !!$z';
	 addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
	 return;
	}
	
		if($lb_is_vote == 1 && !verifyAdmin($login))
	{
		$message = '$z$i$900>> There is a vote running, wait til its over !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		addCall(null,"ChatSendServerMessageToLogin", $current_voting_message, $login);
		return;
	}
// check if login has track in juke
	if(in_array($login,$lb_jbxlogin) && !verifyAdmin($login))
	{
	$msg = '$z$i$f90>> You already have a track in jukebox ! $z';
	addCall(null,"ChatSendServerMessageToLogin", $msg, $login);	
	return;
	}	

	$file = tmx_download($login, $params[0]);
	if($file == "") return;

// check if track is in juke
	if(in_array($lb_xtrack['UId'],$lb_jbxuid))
	{
	$msg = '$z$i$f90>> Track is already in jukebox ! $z';
	addCall(null,"ChatSendServerMessageToLogin", $msg, $login);	
	return;
	}	
	
	$counter = count($_ChallengeList);
	for($i=0; $i<$counter; $i++)
		{ //print_r($_ChallengeList[$i]);
		
		 if($_ChallengeList[$i]['UId'] == $lb_xtrack['UId'])
			{	
				$msg = localeText(null,'emotic').'>> Challenge is in tracklist !!$z';
				addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
				$tracknumber = $i+1;
				$lb_msgs[$login][0]='dothefunkyjuke';
				chat_jbx($author, $login, array($tracknumber));	
				return;
			}			
		}
	
	// admin doesnt need a vote
	if(!verifyAdmin($login)) 
	{
	 tmxvote($author, $login, $lb_xtrack['Name'], $lb_xtrack['Author']);
	 return;
	}
	insert_tmx($author, $login);	
}

function tmxvote($nick, $login, $name, $trackauthor)
{	global $lb_is_vote, $lb_vote_reason, $current_voting_message, $lb_votelogin;
	
	$lb_is_vote = 1;
	$lb_vote_reason = 'tmx';
	$lb_votelogin = $login;
	$smalnick=stripEnlarge($nick);
	$smalname=stripEnlarge($name);

	$msg = '$i'.$smalnick.'$fff wants to play '.$smalname.'$fff from tmx (Author: '.$trackauthor.'$z$i$fff)';
	$current_voting_message = '$i'.$smalnick.'$fff >> $w$f00TMX$z$i '.$smalname.'$z';
	//addCall(null,"SendDisplayServerMessage", $msg , 'Yes','No',0);
		addCall(null,"ChatSendServerMessage", $msg);
	$msg = localeText(null,'highlight').'Your turn : type y or n ';
		addCall(null,"ChatSendServerMessage", $msg);
}

function insert_tmx($nick, $login)
{	global $_ChallengeList, $lb_jbx, $_CurrentChallengeIndex, $lb_tmx_local_file, $lb_jbx_tmx,
			$lb_jbxnames, $lb_jbxmax, $jukeboxbuffer, $lb_jbxlogin, $lb_jbxuid, $lb_xtrack;
	
	$badchar = array("*",";","<",">","|","?","\"");
	$lb_xtrack['File'] = str_replace($badchar,'_',$lb_xtrack['File']);
	//print_r($lb_xtrack['File']);
	file_put_contents($lb_xtrack['File'],$lb_tmx_local_file);
	$index = count($_ChallengeList);
	addCall(null,"AddChallenge",$lb_xtrack['File']);
//	addCall(true,'GetChallengeList',$_CurrentChallengeIndex+300,0);
		
	$msg = localeText(null,'server_prefix').'$z$i$fff '.$lb_xtrack['Name'].
		   localeText(null,'emotic').' from tmx jukeboxed by '.$nick.'$z';
		addCall(null,"ChatSendServerMessage", $msg);
		array_push($lb_jbx, $lb_xtrack['File']);
		array_push($lb_jbxnames, $lb_xtrack['Name']);
		array_push($lb_jbxlogin, $login);
		array_push($lb_jbxuid, $lb_xtrack['UId']);
		array_push($lb_jbx_tmx,$lb_xtrack['File']);
		array_push($lb_jbx_tmx,$lb_xtrack['UId']);
}
////////////////////////////////
//** functions multimessage **//
////////////////////////////////


function multi_message($uid, $login, $answer)
{	global $lb_msgs, $lb_pagecount, $lb_maxpagecount, $_PlayerList, $lb_is_vote, $lb_is_list, $lb_vote_result_yes, $lb_vote_result_no, $lb_allvoted, $lb_vote_result, $lb_votelimit,$needed_votes_dsp, $_Game, $lb_ml_page;
	
 	// send other messages
 	if($lb_is_list !=0 && $lb_is_vote == 0)
 	{		
		if ($answer == 2)
		{			 
		$displaypage = $lb_maxpagecount[$login] - $lb_pagecount[$login] ;
		if($_Game == 'TMN')
		addCall(true,"SendDisplayServerMessageToLogin", $login, $lb_msgs[$login][$displaypage], 'Close','Next',0);
		else
		{
		$lb_ml_page[$login] = $displaypage;
	//	manialinksAddManialinkHook($login,'lb_ml','lb_ml_mm',2);
	// diplay the manialink
		lb_ml_dsp($login,"show");
		$lb_is_list = 0;
		}
		$lb_pagecount[$login]--;
			if($lb_pagecount[$login] < 0) $lb_pagecount[$login] = $lb_maxpagecount[$login] ;
		}
		if ($answer == 1) $lb_is_list = 0;
	}
	
	if($lb_is_list == 0 && $lb_is_vote != 0)
	{	
	 	$counter = count($_PlayerList);
		$needed_votes = ceil($counter*$lb_votelimit['tmxratio']);
				
		if($lb_allvoted < $counter)
		{
			if($answer == 1)
			{
			$lb_vote_result_yes++;
			$lb_allvoted++;
			$needed_votes_dsp = $needed_votes - $lb_vote_result_yes;
			check_results($lb_vote_result_yes / $counter, 'yes');
			//return;
			}
		
			if($answer == 2)
			{
			$lb_vote_result_no++;
			$lb_allvoted++;
			check_results($lb_vote_result_no / $counter, 'no');
			//return;
			}
				if($lb_allvoted >= $counter)
				{
				$lb_allvoted = 0;
				$lb_is_vote = 0;
				//addCall(null,"SendHideServerMessage");
				}
		}	
		
		
	}
}

function check_results($result, $param)
{ global $lb_votelimit, $lb_vote_reason, $lb_vote_result_no, $lb_vote_result_yes, $lb_allvoted, $lb_is_vote, 
		$lb_generalvote_result, $lb_generalvote, $is_next, $lb_votelogin;
	
	$lb_generalvote_result = $result;
	$negative_voteratio = (1.0 - $lb_votelimit['ratio']);
	$lb_vote_ratio = $lb_votelimit['ratio'];
	if($lb_vote_reason == 'tmx')
		{	$negative_voteratio = (1.0 - $lb_votelimit['tmxratio']);
			$lb_vote_ratio = $lb_votelimit['tmxratio'];
		}
	settype($lb_vote_ratio,"double");
	settype($negative_voteratio,"double");
	
	if($param == 'no')
	{
		if($negative_voteratio <= $result)
		{
		addCall(null,"SendHideServerMessage");
		$msg = '$z$i$w$fffVote Failed !! $z';
		addCall(null,"ChatSendServerMessage", $msg);
		$lb_vote_result_no = 0;
		$lb_vote_result_yes = 0;
		$lb_allvoted = 0;
		$lb_is_vote = 0;
		$lb_vote_reason = 'none';
		$lb_generalvote = array();
		if($lb_votelimit['status'] == 1)
		addCall(null,"SetCallVoteRatio", 1.0);
		}
	}

	if($param == 'yes')
	{	
	 	
		if($lb_vote_ratio <= $result)
		{
		addCall(null,"SendHideServerMessage");
		$msg = '$z$i$w$fff Vote Passed !! $z';
		addCall(null,"ChatSendServerMessage", $msg);
		$lb_vote_result_no = 0;
		$lb_vote_result_yes = 0;
		$lb_allvoted = 0;
		$lb_is_vote = 0;
				
		if($lb_vote_reason == 'restart') 
		{
		 $restart_passed = 1;
		 restart_by_voting();
		}
		if($lb_vote_reason == 'next') next_by_voting();
		if($lb_vote_reason == 'kick') kick_by_voting();
		if($lb_vote_reason == 'ban') ban_by_voting();
		if($lb_vote_reason == 'tmx') insert_tmx('voting',$lb_votelogin);
		
		$lb_vote_reason = 'none';
		$lb_generalvote = array();
		
		}		
	}
	
}

function vote_timing($starting_time)
{		global $start_time, $end_time, $restart_time, $_GameInfos,$_ServerOptions,
		$lb_maxres, $lb_maxnext, $lb_defmaxnext, $lb_defmaxres, $restart_passed, $lb_is_vote, $lb_generalvote, $lb_votelimit;

	$start_time = $starting_time;
	$end_time = $starting_time + ($_GameInfos['TimeAttackLimit'] /1000)	;
	$restart_time = $end_time - ($_ServerOptions['CurrentCallVoteTimeOut'] /1000);
	
	if($lb_votelimit['status'] == 1)
	addCall(null,"SetCallVoteRatio", 1.0);
	//print_r($_GameInfos);
	//print_r($_ServerOptions);
	$restart_passed = 0;
	$lb_is_vote = 0;
	$lb_maxnext = $lb_votelimit['maxnext'];
	$lb_generalvote = array();
		
}

function manage_vote($time)
{		global $_ChallengeList, $_CurrentChallengeIndex, $_NextChallengeIndex, $lb_maxres, 
				$lb_maxnext, $lb_vote_result_yes, $lb_vote_result_no, $_ChallengeInfo, $lb_tracktorestart,
				$lb_is_vote, $_ServerOptions, $lb_time_disable, $lb_generalvote, $lb_votelimit;

	if($time == 1) //race begin
	{
	
			$lb_maxnext = $lb_votelimit['maxnext'];
			if($lb_tracktorestart != $_ChallengeInfo['UId'])
			$lb_maxres = $lb_votelimit['maxres'];
			$lb_vote_result_yes = 0;
			$lb_vote_result_no = 0;
			$lb_generalvote = array();
	 // print_r($_CurrentChallengeIndex);
	 show_pb();
	 show_ranking();
	 return;	
	}
	
	if($time == 2) //race end
	{
	 			$lb_is_vote = 0;
				$lb_generalvote = array();
				$lb_vote_result_yes = 0;
				$lb_vote_result_no = 0;
				
	wins_counter();
	little_tut();
	atm();
	return;
	}
	
	if($time == 3)
	{
		if($lb_time_disable > 0)
		{	
		 	$time_current = time();
			if($time_current > $lb_time_disable) 
			{
				$lb_time_disable = 0;
				if($lb_votelimit['status'] == 1)
				addCall(null,"SetCallVoteRatio", 1.0);
				$lb_is_vote = 0;
				$lb_generalvote = array();
				$lb_vote_result_yes = 0;
				$lb_vote_result_no = 0;
				
			}
		}			
	}
}

function little_tut()
{	global $lb_little_tut, $lb_message_trigger, $lb_def_message_trigger, $lb_def_message_counter,
			$message_counter, $_PlayerList, $lb_pinfos;
	
	$col1 = '$z$i$3ff';

	if ($lb_little_tut == 0) return;
	
	$ltnick = '$z$i$w$f00Info $fff>> $z';
	
	$msg[0] = ' /list (shows all tracks on server)';
	$msg[1] = ' /list number (show tracks with authortime smaller number)'; 
	$msg[2] = ' /list numb1 numb2 (show tracks with authortime bigger numb1 and smaller numb2)';
	$msg[3] = ' /list text (show tracks with text in name or authors name)';
	$msg[4] = ' /recs (show top 5 local records)';
	$msg[5] = ' /recs all (show all local records)';
	$msg[6] = ' /res (start a restart vote)';
	$msg[7] = ' /next (start a next vote)';
	$msg[8] = ' /add tmxid (starts a tmx vote for track with tmxid)';
	$msg[9] = ' /y (awnser a vote with yes u can also use y)';
	$msg[10] = ' /n (awnser a vote with no u can also use n)';
	$msg[11] = ' /karma (displays current track karma)';
	$msg[12] = ' ++ (votes karma good for current track)';
	$msg[13] = ' -- (votes karma bad for current track)';
	$msg[14] = ' /jbx or /jukebox (displays the current tracks in jukebox)';
	$msg[15] = ' /jbx number (put the track number from list in jukebox)';
	$msg[16] = ' /maps (shows the next 3 tracks in playlist)'; 
	$msg[17] = ' /ban login (starts a ban vote for the specified login)';
	$msg[18] = ' /kick login (starts a kick vote for the specified login)';
	$msg[19] = ' have fun !';
	$msg[20] = ' /pl (shows current players on server)';
	$msg[21] = ' /showrecs (enable or disable the diplay of local records)';
	$msg[22] = ' /showinfo (enable or disable the diplay of infomessages)';
	$msg[23] = ' /wins (shows how often you have won)';
	$msg[24] = ' /rank (shows your current server rank with score)';
	$msg[25] = ' /top (shows current server ladder)';
	$msg[26] = ' /list nofinish (show tracks on server where you didnt finsh)';
	$msg[27] = ' /list notop (shows tracks where you are NOT ranked)';
	$msg[28] = ' /list notop number (shows tracks where you ar NOT in top number)';
	$msg[29] = ' /jbx undo (removes your previous jukeboxed track)';
	$msg[30] = ' /tmx new (show new tracks from tmx)';
	$msg[31] = ' /tmx a authorname (show tmx tracks from author)';
	$msg[32] = ' /tmx t trackname (show tmx tracks with trackname)';
	$msg[33] = ' /tmx a authorname t trackname (show tmx tracks)';
	
	$counter = count($msg);
	
	if ($lb_message_trigger == 0)
	{
	$message = $ltnick.$col1.$msg[$message_counter].'$z';
	foreach($_PlayerList as $key)
		{
		$login = $key['Login'];
		$showtoplayer = $lb_pinfos[$login]['ShowInfo'];
		if($showtoplayer == 1)	addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		}
	$lb_message_trigger = $lb_def_message_trigger;
	}
	$lb_message_trigger--;
	$message_counter++;
	if($message_counter >= $counter) $message_counter = $lb_def_message_counter;
}

function chat_showrecs($author,$login,$params)
{	global $lb_pldb, $lb_pinfos;
	
	$data=$lb_pinfos[$login];
			
		if($data['ShowRecs'] == 1)
			{
				$message = '$z$i$000>> Show Records is now $f00OFF !!$z';
				addCall(null,"ChatSendServerMessageToLogin", $message, $login);
				$table = $data['PlayerId'];
				$lb_pldb->executeQuery("UPDATE $table
										SET ShowRecs = '0'");
				$lb_pinfos[$login]['ShowRecs'] = 0;
				return;
			}
		if($data['ShowRecs'] == 0)
			{
				$message = '$z$i$000>> Show Records is now $f00ON !!$z';
				addCall(null,"ChatSendServerMessageToLogin", $message, $login);
								$table = $data['PlayerId'];
				$lb_pldb->executeQuery("UPDATE $table
										SET ShowRecs = '1'");
				$lb_pinfos[$login]['ShowRecs'] = 1;
				return;
			}	
}

function chat_showinfo($author,$login,$params)
{	global $lb_pldb, $lb_pinfos;

$data=$lb_pinfos[$login];			
		if($data['ShowInfo'] == 1)
			{
				$message = '$z$i$000>> Show Infos is now $f00OFF !!$z';
				addCall(null,"ChatSendServerMessageToLogin", $message, $login);
				$table=$data['PlayerId'];
				$lb_pldb->executeQuery("UPDATE $table
										SET ShowInfo = '0'");
				$lb_pinfos[$login]['ShowInfo'] = 0;
				return;
			}
		if($data['ShowInfo'] == 0)
			{
				$message = '$z$i$000>> Show Infos is now $f00ON !!$z';
				addCall(null,"ChatSendServerMessageToLogin", $message, $login);
				$table=$data['PlayerId'];
				$lb_pldb->executeQuery("UPDATE $table
										SET ShowInfo = '1'");
				$lb_pinfos[$login]['ShowInfo'] = 1;
				return;
			}	
}

function wins_counter()
{		global $lb_pldb, $_Ranking, $lb_pinfos;
$col1 = '$z$i$3ff';
$col2 = '$z$i$f3c';

	if(!isset($_Ranking)) return;
	$players_ingame = count($_Ranking);
	if($players_ingame <= 1) return;
	if($_Ranking[0]['BestTime'] == -1) return;
	
	$login = $_Ranking[0]['Login'];
	$data = $lb_pinfos[$login];

	$wins = $data['Wins'] + 1;
	$score = $data['Score'] +1;
	$table = $data['PlayerId'];
	$lb_pldb->executeQuery("UPDATE $table
							SET Wins = '$wins', Score = '$score'");

	$lb_pinfos[$login]['Wins'] = $wins;
	$lb_pinfos[$login]['Score'] = $score;
	
	$message = $col1.'Good Game ! You won the '.$col2.$wins.'.'.$col1.' time !';
	addCall(null,"ChatSendServerMessageToLogin", $message, $_Ranking[0]['Login']);
		
}

function chat_wins($author, $login, $params)
{	global $lb_pldb, $lb_pinfos;
$col1 = '$z$i$3ff';
$col2 = '$z$i$f3c';

	$data = $lb_pinfos[$login];
	$wins = $data['Wins'];
	
	$message = $col1.'You have won '.$col2.$wins.'.'.$col1.' times yet!';
	addCall(null,"ChatSendServerMessageToLogin", $message, $login);

}

function chat_pb($author,$login,$params)
{	global $lb_redb, $_ChallengeInfo, $lb_pinfos;
$col1 = '$z$n$i$f00';
$col2 = '$z$n$i$fff';
$col3 = '$z$i$fff';
$uid=$_ChallengeInfo['UId'];
$recordfile='rec_'.$uid;

	$result=$lb_redb->executeQuery("SELECT *
									FROM $recordfile
									WHERE PlayerTime > '0'
									AND PlayerLogin = '$login'");
	$data=GetArray($result);
	if(!isset($data[0]))
	{
	$message = $col1.'You dont have a record on this track !';
	addCall(null,"ChatSendServerMessageToLogin", $message, $login);
	return;	
	}
	$playerinfos = searchpos_track($login);
			$message = $col1.'PB on this track : '.$col2.dsptime($data[0]['PlayerTime']).$col1.' Date : '.$col2.$data[0]['PlayerDate'].$col1.' Pos : '.$col3.$playerinfos['Position'].$col1.' Finished : '.$col2.$playerinfos['Finished'];
	addCall(null,"ChatSendServerMessageToLogin", $message, $login);
}

function show_pb()
{	global $lb_redb, $_ChallengeInfo, $_PlayerList, $lb_pinfos;
$col1 = '$z$n$i$f00';
$col2 = '$z$n$i$fff';
$col3 = '$z$i$fff';
$uid=$_ChallengeInfo['UId'];
$recordfile='rec_'.$uid;

	foreach($_PlayerList as $player)
		{		
		 $login = $player['Login'];
		 $result=$lb_redb->executeQuery("SELECT *
		 						 		FROM $recordfile
		 						 		WHERE PlayerTime > '0'
								 		AND PlayerLogin = '$login'");
			$data=GetArray($result);	
			if(!isset($data[0]))
			{
			$message = $col1.'You dont have a record on this track !';
			addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
			}
			else
			{
			$playerinfos = searchpos_track($login);
			$message = $col1.'PB on this track : '.$col2.dsptime($data[0]['PlayerTime']).$col1.' Date : '.$col2.$data[0]['PlayerDate'].$col1.' Pos : '.$col3.$playerinfos['Position'].$col1.' Finished : '.$col2.$playerinfos['Finished'];
			addCall(null,"ChatSendServerMessageToLogin", $message, $login);
			}
		}	
}



function show_ranking()
{	global $lb_pldb, $_PlayerList, $lb_pinfos;
//$col1 = '$z$i$ff6';
//$col2 = '$z$i$3ff';
$col1 = localeText(null,'server_message');
$col2 = localeText(null,'highlight');
	
	if(count($lb_pinfos) == 0) return;
	$tmp_ranking = $lb_pinfos;
	$sort_ranking = array();
	 foreach($tmp_ranking AS $uniqid => $row){
        foreach($row AS $key=>$value){
            $sort_ranking[$key][$uniqid] = $value;
        }
    }
	array_multisort($sort_ranking['Score'], SORT_DESC, $tmp_ranking);
    $ranking = array();
    foreach($tmp_ranking as $player)
    {
		if($player['Score'] > 0) array_push($ranking, $player);
	}

	$allranks = count($ranking);

	foreach($_PlayerList as $player)
		{	$hasrank = 0;
				$login = $player['Login'];
				
			for($i = 0; $i < $allranks; $i++)
			{
				if ($ranking[$i]['Login'] == $login)
				{
				$rank = $i+1;
				$score = $lb_pinfos[$login]['Score'];
				$message = $col1.'Your server rank is : '.$col2.$rank.$col1.' / '.$col2.$allranks.$col1.' Score : '.$col2.$score;
				addCall(null,"ChatSendServerMessageToLogin", $message, $login);
				$hasrank = 1;
				break;
				}
			}
			if($hasrank == 0)
			{
				$message = $col1.'Your have no rank yet !  Score : '.$col2.'0';
				addCall(null,"ChatSendServerMessageToLogin", $message, $login);
			}
		}		
}
function announce_player_server_rank($login)
{	global $_players, $_Game;

		$teamname = $_players[$login]['TeamName'];
	if($teamname == '') $teamname = 'NoTeam';
		
	$msg = localeText(null,'interact').'Welcome : '.$_players[$login]['NickName'].
		   localeText(null,'interact').' Login : '.
		   localeText(null,'highlight').$login;
		   
	addCall(null,'ChatSendServerMessage',$msg);
	
	$result = chat_rank(0,$login,'join');
		
	$msg = localeText(null,'interact').' SrvRank : '.
		   localeText(null,'highlight').$result['Rank'].
		   localeText(null,'interact').' Score : '.
		   localeText(null,'highlight').$result['Score'];
	if($_Game == 'TMU')
	{
		$msg .= localeText(null,'interact').' Nation : '.
				localeText(null,'highlight').strtoupper($_players[$login]['Nation']);
	}
	elseif($_Game == 'TMN')
	{	 $msg .= localeText(null,'interact').' Team : '.
		         localeText(null,'highlight').stripColors($teamname);  
	}
	addCall(null,'ChatSendServerMessage',$msg);
	
}

function chat_rank($author, $login, $params)
{	global $lb_pldb, $_client, $lb_pinfos;
//$col1 = '$z$i$ff6';
//$col2 = '$z$i$3ff';
$col1 = localeText(null,'server_message');
$col2 = localeText(null,'highlight');
	
	$tmp_ranking = $lb_pinfos;
	$sort_ranking = array();
	 foreach($tmp_ranking AS $uniqid => $row){
        foreach($row AS $key=>$value){
            $sort_ranking[$key][$uniqid] = $value;
        }
    }
	array_multisort($sort_ranking['Score'], SORT_DESC, $tmp_ranking);
    $ranking = array();
    foreach($tmp_ranking as $player)
    {
		if($player['Score'] > 0) array_push($ranking, $player);
	}

	$allranks = count($ranking);
	
	$hasrank = 0;
			for($i = 0; $i < $allranks; $i++)
			{	
				if ($ranking[$i]['Login'] == $login)
				{
				$nick = $ranking[$i]['NickName'];
				$nick = stripEnlarge($nick);
				$rank = $i+1;
				$score = $lb_pinfos[$login]['Score'];
				$message = $col1.'Your server rank : '.$col2.$rank.$col1.' / '.$col2.$allranks.$col1.' Score : '.$col2.$score;
				if(isset($params) && $params == 'join') 
				return(array('Rank' => $rank,'Score' => $ranking[$i]['Score']));
				addCall(null,"ChatSendServerMessageToLogin", $message, $login);
				$hasrank = 1;
				break;
				}
			}	
				if($hasrank == 0)
				{
				 if(isset($params) && $params == 'join') 
				 return(array('Rank' => 'NoRank','Score' => 0));
				$message = $col1.'Your have no rank yet !  Score : '.$col2.'0';
				addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
				}
}

function reset_ranking_track()
{ 	global $lb_redb, $_ChallengeInfo, $lb_maxtop, $lb_oldranking, $lb_update_ranking, $lb_update_ranking_logins;

print_r('Loading current scores for next track...'."\n");
$uid=$_ChallengeInfo['UId'];
$recordfile='rec_'.$uid;

$lb_update_ranking = array();
$lb_update_ranking_logins = array();
if(!file_exists(DB_DIR. 'records/'.$recordfile.'.txt')) return;
		$result=$lb_redb->executeQuery("SELECT *
								FROM $recordfile
								WHERE PlayerTime > '0'
								ORDER BY PlayerTime ASC");
				
		$data=GetArray($result);
		if(!isset($data[0]))
		{
			$lb_oldranking = 0;
			return;
		}
		$rankings = count($data);
		if($rankings > $lb_maxtop) $rankings = $lb_maxtop;
		
		for($i = $rankings; $i > 0; $i--)
		{	
		 	$login = $data[$i-1]['PlayerLogin'];
		 	$points = $rankings-$i+1;
		 	$searchlogin = search_lb_pinfos($login);
			 if($searchlogin != 0)
		 	{
		 	//$oldscore = $lb_pinfos[$login]['Score'];
		 	//$lb_pinfos[$login]['Oldscore'] = $oldscore;
		
			 $lb_update_ranking[$login] = $points;
			 array_push($lb_update_ranking_logins, $login); 
			//$lb_update_ranking[$i] = array('Login' => $login, 'Points' => $points);
			}
		}		
		$lb_oldranking = 1;
		print_r('Done !!'."\n");
		//print_r($lb_update_ranking);
}

function update_ranking()
{	global $lb_redb, $lb_pldb, $_ChallengeInfo, $lb_maxtop, $lb_oldranking, $lb_update_ranking, $lb_update_ranking_logins,
			$lb_pinfos, $lb_ptables;


	print_r('Getting current endpoints'."\n");
	$uid=$_ChallengeInfo['UId'];
	$recordfile='rec_'.$uid;
		//get current rankings for track
		if(!file_exists(DB_DIR.'records/'.$recordfile.'.txt')) return;
		$result=$lb_redb->executeQuery("SELECT *
										FROM $recordfile
										WHERE PlayerTime > '0'
										ORDER BY PlayerTime ASC");
		$data=GetArray($result);
		if(!isset($data[0])) return; //nutting to update
		
		$players_to_update=array();
		$rankings = count($data);
		if($rankings > $lb_maxtop) $rankings = $lb_maxtop;
		// calculate current score for track
		for($i = $rankings; $i > 0; $i--)
		{	$found = 0;
		 	$points = $rankings-$i+1;
		 	$login = $data[$i-1]['PlayerLogin'];
		 	$score = $lb_pinfos[$login]['Score'];
			//$lb_new_ranking[$i] = array('Login' => $login, 'Points' => $points);
			//foreach($lb_update_ranking as $player)
			if(in_array($login, $lb_update_ranking_logins))
			{$found=1;
			 $newscore = $score + $points - $lb_update_ranking[$login];
				if($newscore != $score)
					{
					$lb_pinfos[$login]['Score'] = $newscore;
					array_push($players_to_update, $login);
					}	
			}
			if($found == 0)
			{
			$lb_pinfos[$login]['Score'] = $score + $points;
			array_push($players_to_update, $login);	
			}
				
		}		
		
		print_r('UPDATING FILES'."\n");
		//print_r($players_to_update);
		
	
foreach($players_to_update as $player)
 		{
 			$table = $lb_pinfos[$player]['PlayerId'];
 			$score = $lb_pinfos[$player]['Score'];
 			$lb_pldb->executeQuery("UPDATE $table
 									SET Score = '$score'
									WHERE Login = '$player'");
 			//print_r($player);
 		}

		
	print_r('DONE'."\n");
	
}


function chat_top($author, $login, $params)
{	global $lb_maxpagecount, $lb_pagecount, $lb_is_list, $lb_msgs, $lb_col1, $lb_sql, $lb_pinfos;

$col11 = '$z$i$0ff'; //'$z$i$93c';
$col2 = '$z$i$0f0'; //'$z$i$c0f';
//show all ranks in popub
	$maxline = 10;
	$page = 0;
	$lb_maxpagecount[$login] = 0;
	$lb_pagecount[$login] = 0;
	
	for ($i = 0; $i < 1600 ; $i++)
	{$lb_msgs[$login][$i] = ' ';} // clear previous message
	
	$tmp_ranking = $lb_pinfos;
	$sort_ranking = array();
	 foreach($tmp_ranking AS $uniqid => $row){
        foreach($row AS $key=>$value){
            $sort_ranking[$key][$uniqid] = $value;
        }
    }
	array_multisort($sort_ranking['Score'], SORT_DESC, $tmp_ranking);
    $ranking = array();
    foreach($tmp_ranking as $player)
    {
		if($player['Score'] > 0) array_push($ranking, $player);
	}

	$allranks = count($ranking);
	$rankforpage = 0;
	 for($i=0; $i < $allranks; $i++)
	 {		
			 $searchlogin = $ranking[$i]['Login'];
			 if($searchlogin == $login) {$rankforpage = $i+1;}
	}
	
	$lb_msgs[$login][$page] = localeText(null,'server_message').'     Rank -  Score - Wins - Nick'."\n";
		for($i=0; $i < $allranks ;$i++)
			{
			 $nick = $ranking[$i]['NickName'];
			 $searchlogin = $ranking[$i]['Login'];
			 $nick = stripEnlarge($nick);
			 $rank = $i+1;
			 			 
			 if($rank <= 99999) $placeholder_rank = ' ';
			 if($rank <= 9999) $placeholder_rank = '  ';
			 if($rank <= 999) $placeholder_rank = '   ';
 			 if($rank <= 99) $placeholder_rank = '    ';
			 if($rank <= 9) $placeholder_rank = '      ';
			 if($ranking[$i]['Wins'] <= 99999) $placeholder_wins = ' ';
			 if($ranking[$i]['Wins'] <= 9999) $placeholder_wins = '  ';
			 if($ranking[$i]['Wins'] <= 999) $placeholder_wins = '   ';
			 if($ranking[$i]['Wins'] <= 99) $placeholder_wins = '    ';
			 if($ranking[$i]['Wins'] <= 9) $placeholder_wins = '      ';
			 if($ranking[$i]['Score'] <= 99999) $placeholder_score = ' ';
			 if($ranking[$i]['Score'] <= 9999) $placeholder_score = ' ';
			 if($ranking[$i]['Score'] <= 999) $placeholder_score = '   ';
			 if($ranking[$i]['Score'] <= 99) $placeholder_score = '     ';
			 if($ranking[$i]['Score'] <= 9) $placeholder_score = '      ';
			 
			 
	$lb_msgs[$login][$page] .= $placeholder_rank.$col11.$rank.'. - '.$placeholder_score.$col2.$ranking[$i]['Score'].$col11.' - '.$placeholder_wins.$col2.$ranking[$i]['Wins'].' - '.$nick."\n";
			$maxline--;
			if($maxline <= 0)
			{$maxline=10;
			if($rankforpage > 0)
			{
			$lb_msgs[$login][$page] .= "\n".localeText(null,'server_message').'Your Rank :'."\n";
			$lb_msgs[$login][$page] .= $placeholder_rank.$col11.$rankforpage.
									'. - '.$placeholder_score.$col2.$ranking[$rankforpage-1]['Score'].
									$col11.' - '.$placeholder_wins.$col2.$ranking[$rankforpage-1]['Wins'].
									' - '.$ranking[$rankforpage-1]['NickName']."\n";
			}
			elseif($rankforpage <= 0)
			{
			$lb_msgs[$login][$page] .= localeText(null,'server_message')."\n";
			$lb_msgs[$login][$page] .= localeText(null,'server_message').'You have no Rank yet..'."\n";
			}
			 $page++;
			 $lb_pagecount[$login]++;
			 $lb_maxpagecount[$login]++;
			 $lb_msgs[$login][$page] .= localeText(null,'server_message').'     Rank -  Score - Wins - Nick'."\n";
			}
			}
	$lb_is_list = 1;
	multi_message($author, $login, 2);
}

function chat_votelimit($author, $login, $params)
{	global $lb_votelimit;

	if(!verifyAdmin($login)) return;

	if(!isset($params[0]))
	{	
	 	if($lb_votelimit['status'] == 1) $status = 'ON';
	 	else $status = 'OFF';
		$message = '$z$i$000>> Votelimit-Status is $f00'.$status.' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		$message = '$z$i$000>> Votelimit-Maxres is $f00'.$lb_votelimit['maxres'].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		$message = '$z$i$000>> Votelimit-Maxnext is $f00'.$lb_votelimit['maxnext'].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		$message = '$z$i$000>> Votelimit-Ratio is $f00'.$lb_votelimit['ratio'].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		$message = '$z$i$000>> Votelimit-TMXRatio is $f00'.$lb_votelimit['tmxratio'].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		return;	
	}
	
	if($params[0] == 'on')
	{
		$lb_votelimit['status'] = 1;
		$message = '$z$i$000>> Votelimit is now $f00ON !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
	}
	elseif($params[0] == 'off')
	{
		$lb_votelimit['status'] = 0;
		$message = '$z$i$000>> Votelimit is now $f00OFF !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
	}
	elseif($params[0] == 'maxres' && isset($params[1]) && is_numeric($params[1]))
	{
		$lb_votelimit['maxres'] = $params[1];
		$message = '$z$i$000>> Maxrestart is now $f00'.$params[1].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
	}
	elseif($params[0] == 'maxnext' && isset($params[1]) && is_numeric($params[1]))
	{
		$lb_votelimit['maxnext'] = $params[1];
		$message = '$z$i$000>> Maxnext is now $f00'.$params[1].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
	}
	elseif($params[0] == 'ratio' && isset($params[1]) && is_numeric($params[1]))
	{
		$lb_votelimit['ratio'] = $params[1];
		$message = '$z$i$000>> Voteratio is now $f00'.$params[1].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		settype($lb_votelimit['ratio'],"double");
	}
	elseif($params[0] == 'tmxratio' && isset($params[1]) && is_numeric($params[1]))
	{
		$lb_votelimit['tmxratio'] = $params[1];
		$message = '$z$i$000>> TMXVoteratio is now $f00'.$params[1].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		settype($lb_votelimit['tmxratio'],"double");
	}
}

function atm()
{ global $_TracksDirectory, $_ChallengeInfo, $lb_atm, $_ChallengeList, $_CurrentChallengeIndex;
	
	$col1 = '$z$i$fff';
		if($lb_atm['status'] == 0) return;
		
		$result=check_karma('1234');
		$needed_negative_votes = $lb_atm['votes'] - ($lb_atm['votes'] * ($lb_atm['ratio']/100));
		
		if($result[1] < $lb_atm['votes'] && $needed_negative_votes >= $result[2]) return;
		if($result[0] >= $lb_atm['ratio']) return;		
		//$filename = $_ChallengeInfo['FileName'];
		$filename = $_ChallengeList[$_CurrentChallengeIndex]['FileName'];
		addCall(null,"RemoveChallenge",$filename);
		$trackname = stripEnlarge($_ChallengeInfo['Name']);
		$msg = $col1.'>> ATM'.localeText(null,'server_message').' removed track : $fff'.$trackname.localeText(null,'server_message').' Ratio: '.$result[0].'%$z';
		addCall(null,"ChatSendServerMessage", $msg);
		


}

function chat_joinmsg($author, $login, $params)
{	global $lb_joinmsg;

	if(!verifyAdmin($login)) return;
	
	if(!isset($params[0]))
	{
		if($lb_joinmsg == 0) $status = 'OFF';
		else $status = 'ON';
		$message = '$z$i$000>> Join message is $f00'.$status.' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		return;
	}
	elseif($params[0] == 'on')
	{
		$message = '$z$i$000>> Join message is now $f00 ON !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		$lb_joinmsg = 1;
		return;
	}
	elseif($params[0] == 'off')
	{
		$message = '$z$i$000>> Join message is now $f00 OFF !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		$lb_joinmsg = 0;
		return;
	}
}

function chat_atm($author, $login, $params)
{	global $lb_atm;
	
	if(!verifyAdmin($login)) return;

	if(!isset($params[0]))
	{	
	 	if($lb_atm['status'] == 1) $status = 'ON';
	 	else $status = 'OFF';
		$message = '$z$i$000>> ATM-Status is $f00'.$status.' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		$message = '$z$i$000>> ATM-MinVotes is $f00'.$lb_atm['votes'].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		$message = '$z$i$000>> ATM-Ratio is $f00'.$lb_atm['ratio'].'% !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		return;	
	}
	
	elseif($params[0] == 'on')
	{
		$message = '$z$i$000>> ATM-Status is now $f00 ON !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		$lb_atm['status'] = 1;
		return;
	}
	elseif($params[0] == 'off')
	{
		$message = '$z$i$000>> ATM-Status is now $f00 OFF !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);
		$lb_atm['status'] = 0;
		return;
	}
	
	elseif($params[0] == 'votes' && isset($params[1]) && is_numeric($params[1]) && $params[1] > 2)
	{
		$lb_atm['votes'] = $params[1];
		$message = '$z$i$000>> ATM-MinVotes is now $f00'.$params[1].' !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		settype($lb_atm['votes'],"int");
		return;
	}
	elseif ($params[0] == 'ratio' && isset($params[1]) && is_numeric($params[1]) && $params[1] <= 100 && $params[1] >= 0)
	{
		$lb_atm['ratio'] = $params[1];
		$message = '$z$i$000>> ATM-Ratio is now $f00'.$params[1].'% !!$z';
		addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		settype($lb_atm['ratio'],"double");
		return;
	}
}

function chat_tmx($author, $login, $params)
{	global $lb_tmxadd;

	$arg=array();
	$failure=1;
	if(isset($params[1]))
	{
	 $arg = explode(' ', $params[1]);
	}	
	
	if(!isset($params[0]) || $params[0] == 'help')
		{	
		$msg  = localeText(null,'server_message').'TMX help : '."\n";
		$msg .= localeText(null,'emotic').'/tmx $f00a name '.
				localeText(null,'emotic').'( search for author name )'."\n";
		$msg .= localeText(null,'emotic').'/tmx $f00t name '.
				localeText(null,'emotic').'( search for track name )'."\n";
		$msg .= localeText(null,'emotic').'/tmx $f00a name t name '.
				localeText(null,'emotic').'( search for author and track )'."\n";
		$msg .= localeText(null,'emotic').'/tmx $f00new '.
				localeText(null,'emotic').'( show last uploaded tracks )'."\n";
		
		if(verifyAdmin($login))
		{
		$msg .= localeText(null,'server_message').'Admin help : '."\n";
		$msg .= localeText(null,'emotic').'/tmx $f00all '.
				localeText(null,'emotic').'( allow all players to add tmx tracks )'."\n";
		$msg .= localeText(null,'emotic').'/tmx $f00admin '.
				localeText(null,'emotic').'( allow only admins to add tmx tracks )'."\n";
		}
		
		addCall(null,"SendDisplayServerMessageToLogin", $login, $msg, 'Close','',0);
		return;
		}
	elseif($params[0] == 'all' && verifyAdmin($login))
		{
			$lb_tmxadd = 'all';
			$message = localeText(null,'highlight').'>> /add is now for all players ';
			addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
			return;
		}
	elseif($params[0] == 'admin' && verifyAdmin($login))
		{
			$lb_tmxadd = 'admin';
			$message = localeText(null,'highlight').'>> /add is now admin only ';
			addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
			return;
		}
	elseif($params[0] == 'new')
		{
			search_tmx($login, '','');
			$failure = 0;	
		}	
	elseif($params[0] == 'a' && isset($arg[0]) && !isset($arg[1]))
		{
			search_tmx($login, $arg[0],'');
			$failure = 0;
		}
	elseif($params[0] == 'a' && isset($arg[0]) && isset($arg[1]) && $arg[1] == 't' && isset($arg[2]))
		{
			search_tmx($login, $arg[0], $arg[2]);
			$failure = 0;
		}
	elseif($params[0] == 't' && isset($arg[0]) && !isset($arg[1]))
		{
			search_tmx($login, '', $arg[0]);
			$failure = 0;
		}
	elseif($params[0] == 't' && isset($arg[0]) && isset($arg[1]) && $arg[1] == 'a' && isset($arg[2]))
		{
			search_tmx($login, $arg[2], $arg[0]);
			$failure = 0;
		}
	
	if($failure == 1)
		{
	$message = localeText(null,'highlight').'>> Syntax Error : use /tmx help ';
	addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
		}
}

function keep_tmx($login)
{	global $_ChallengeList, $_ChallengeInfo, $_CurrentChallengeIndex, $_TracksDirectory;
	
    $filename = $_TracksDirectory.$_ChallengeInfo['FileName'];
    $filename_toadd = $_ChallengeInfo['FileName'];

        if(!strstr($filename,'tmpTMX-'))
    {
		$msg = localeText(null,'highlight').'Could not add track !!';
		addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
		return;
	}
	
    $newfilename = str_replace('tmpTMX-','TMX-',$filename);
	$filename_toadd = str_replace('tmxTMX-','TMX-',$filename_toadd);
	rename($filename, $newfilename);

	$msg = localeText(null,'server_prefix').'$z$i$fff '.stripEnlarge($_ChallengeInfo['Name']).
		   localeText(null,'emotic').' is added to tracklist $z';
	addCall(null,"ChatSendServerMessage", $msg);
	
	$_ChallengeInfo['FileName'] = $filename_toadd;
	$_ChallengeList[$_CurrentChallengeIndex]['FileName'] = $filename_toadd;	
}


function search_tmx($login, $track_author, $track_name)
{	global $lb_msgs, $lb_is_list, $lb_pagecount, $lb_maxpagecount, $_Game;

	if($_Game == 'TMU')
	{$result = file_get_contents('http://tmnforever.tm-exchange.com/get.aspx?action=apisearch&'.
								'author='.$track_author.'&track='.$track_name);}
	else
	{$result = file_get_contents('http://nations.tm-exchange.com/get.aspx?action=apisearch&'.
								'author='.$track_author.'&track='.$track_name);}
	
	if(!$result) 
	{
	$message = localeText(null,'highlight').'>> No tracks found !! ';
	addCall(null,"ChatSendServerMessageToLogin", $message, $login);	
	return;
	}
	$table = explode('<BR>', $result);
	$counter = count($table);
	for($i=0; $i<$counter;$i++)
	{
		$infos[$i]=explode("\t",$table[$i]);
	}
	
	$page=0;
	$maxline = 14;
	$lb_maxpagecount[$login] =0;
	$lb_pagecount[$login] = 0;
		for ($i = 0; $i < 1600 ; $i++)
		
	{$lb_msgs[$login][$i] = ' ';} // clear previous message
	
	$startcolor = localeText(null,'emotic');
	$nextcolor = localeText(null,'match2');
	$currentcolor = $startcolor;
	$lb_msgs[$login][$page] = localeText(null,'server_message').'TMX-ID-AUTHOR-NAME-TIME'."\n";
	for($index = 0 ; $index < $counter-1; $index++)
	{	
	 	if($currentcolor == $startcolor) $currentcolor = $nextcolor;
	 	else $currentcolor = $startcolor;
	 	
		$lb_msgs[$login][$page] .= $currentcolor.$infos[$index][0].
								   ' - '.$infos[$index][3].' - '.$infos[$index][1].' - '.$infos[$index][9];
//		$lb_msgs[$login][$page] .= "\n";
		$maxline--;
			if($maxline <= 0)
			{$maxline=10;
			 $page++;
			 $lb_pagecount[$login]++;
			 $lb_maxpagecount[$login]++;
			 $lb_msgs[$login][$page] .= localeText(null,'server_message').'TMX-ID-AUTHOR-NAME-TIME';
			}
	}
	$lb_is_list = 1;
	multi_message('', $login, 2);
}

function chat_load($author, $login, $params)
{		global $_TracksDirectory, $_ChallengeList;

 		if(!verifyAdmin($login)) return;
 		
 		// load plugin configuration 
		if(isset($params[0]) && isset($params[1]) && $params[0] == 'cfg')
		{	
			$result = lb_load_config($params[1]);
		    $cfgfile = './data/'.$params[1].'.lb.cfg.xml';
		    if($result == 1)
		    {
			$msg = localeText(null,'interact').' Loaded configuration : '.
		       	   localeText(null,'highlight').$params[1];  
	
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			return;	
			}
			else
			{
			$msg = localeText(null,'highlight').' Error loading configuration : '.
		       	   localeText(null,'highlight').$params[1].' is not a valid config file !!';  
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);		
			return;
			}
		}
		
		// load matsettings = tracklist and gamesettings replaces current tracklist and gamesettings
		if(isset($params[0]) && isset($params[1]) && $params[0] == 'map')
			{
			$filename = $params[1].'.map.xml';
			$fullfilename = $_TracksDirectory.$filename;
				if(file_exists($fullfilename))
				{
				addCall(null,"LoadMatchSettings",$filename);
				$msg = localeText(null,'interact').' Loaded next Tracklist and Gameinfos from : '.
		       	   		localeText(null,'highlight').$params[1];  
	
				addCall(null,"ChatSendServerMessageToLogin", $msg, $login);		
				return;
				}
				else
				{
					$msg = localeText(null,'highlight').' Error loading matchsettings : '.
		       	   	localeText(null,'highlight').$params[1].' is not a valid matchfile !!';  
					addCall(null,"ChatSendServerMessageToLogin", $msg, $login);		
					return;
				}
			}
		
		//insert playlist from matchsettings file into current tracklist	
		if(isset($params[0]) && isset($params[1]) && $params[0] == 'imap')
			{
			$filename = $params[1].'.map.xml';
			$fullfilename = $_TracksDirectory.$filename;
				if(file_exists($fullfilename))
				{
				addCall(null,"InsertPlaylistFromMatchSettings",$filename);
				$msg = localeText(null,'interact').' Inserted Tracklist from : '.
		       	   		localeText(null,'highlight').$params[1];  
	
				addCall(null,"ChatSendServerMessageToLogin", $msg, $login);		
				return;
				}
				else
				{
					$msg = localeText(null,'highlight').' Error loading Tracklist : '.
		       	   	localeText(null,'highlight').$params[1].' is not a valid matchfile !!';  
					addCall(null,"ChatSendServerMessageToLogin", $msg, $login);		
					return;
				}
			}
		
		//add playlist from matchsettings file at end of current tracklist
		if(isset($params[0]) && isset($params[1]) && $params[0] == 'amap')
			{
			$filename = $params[1].'.map.xml';
			$fullfilename = $_TracksDirectory.$filename;
				if(file_exists($fullfilename))
				{
				addCall(null,"AppendPlaylistFromMatchSettings",$filename);
				$msg = localeText(null,'interact').' Added Tracklist from : '.
		       	   		localeText(null,'highlight').$params[1];  
	
				addCall(null,"ChatSendServerMessageToLogin", $msg, $login);		
				return;
				}
				else
				{
					$msg = localeText(null,'highlight').' Error loading Tracklist : '.
		       	   	localeText(null,'highlight').$params[1].' is not a valid matchfile !!';  
					addCall(null,"ChatSendServerMessageToLogin", $msg, $login);		
					return;
				}
			}
		
		//replace current playlist with playlist from matchsettings file but keep the gamesettings
		if(isset($params[0]) && isset($params[1]) && $params[0] == 'rmap')
			{
			$filename = $params[1].'.map.xml';
			$fullfilename = $_TracksDirectory.$filename;
				if(file_exists($fullfilename))
				{
								//build the list
								$removal = array();
								foreach($_ChallengeList as $track)
								{
									array_push($removal,$track['FileName']); 
								}
								//remove the tracks
								addCall(null,"RemoveChallengeList",$removal);
								
				addCall(null,"AppendPlaylistFromMatchSettings",$filename);
				$msg = localeText(null,'interact').' Replaced current Tracklist from : '.
		       	   		localeText(null,'highlight').$params[1];  
	
				addCall(null,"ChatSendServerMessageToLogin", $msg, $login);		
				return;
				}
				else
				{
					$msg = localeText(null,'highlight').' Error loading Tracklist : '.
		       	   	localeText(null,'highlight').$params[1].' is not a valid matchfile !!';  
					addCall(null,"ChatSendServerMessageToLogin", $msg, $login);		
					return;
				}
			}
	   // helpmessage
				   $msg = localeText(null,'highlight').'Usage: /load cfg filename (to load plugin configuration)'.
		           		  ' /load map[imap/amap/rmap] filename ( map : to load matchsettings and tracklist / '.
							 ' imap : insert only playlist from file to current / amap : add playlist at end / '.
							 ' rmap : replace tracklist from file keep matchsettings ';  
	
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
		
}

function chat_save($author, $login, $params)
{	
	if(!verifyAdmin($login)) return;
	
	if(isset($params[0]) && isset($params[1]) && $params[0] == 'cfg')
		{	
		 	
		 	lb_save_config($params[1]);
			$msg = localeText(null,'interact').' Saved configuration : '.
		           localeText(null,'highlight').$params[1];  
	
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			return;
		}
	
	if(isset($params[0]) && isset($params[1]) && $params[0] == 'map')
		{	
		 	$filename = $params[1].'.map.xml';
			addCall(null,"SaveMatchSettings",$filename);
			$msg = localeText(null,'interact').' Saved matchfile : '.
		           localeText(null,'highlight').$params[1];  
	
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
			return;
		}
	// helpmessage
				   $msg = localeText(null,'interact').'Usage: /save cfg filename (to save plugin configuration)'.
		           		  ' /save map filename (to save matchsettings and tracklist)';  
	
			addCall(null,"ChatSendServerMessageToLogin", $msg, $login);
	
}


function lbEverySecond($event, $seconds)
{
	manage_vote(3);
}
function lbEndRace($event,$Ranking,$ChallengeInfo,$GameInfos)
{
	save_srecords($ChallengeInfo);
	check_jukebox(2);
	manage_vote(2);
	update_ranking();
}
function lbPlayerConnect($event,$login)
{	global $lb_joinmsg;

	player_local_connect($login);
	if($lb_joinmsg != 0)
	announce_player_server_rank($login);
}
function lbPlayerDisconnect($event,$login)
{
	player_local_disconnect($login);
}
function lbPlayerFinish($event,$login,$time)
{	
	update_local_records($login, $time);
}
function lbPlayerChat($event,$login,$message)
{
	karma_vote($login, $message);
}

function lbBeginChallenge($event,$ChallengeInfo,$GameInfos)
{
	//print_r($GameInfos);
	manage_local_records($ChallengeInfo);
	manage_vote(1);
	check_jukebox(1);
	reset_ranking_track();
	
}
function lbBeginRound($event)
{
	vote_timing(time());
}
function lbPlayerServerMessageAnswer($event,$login,$answer)
{
	multi_message(99,$login,$answer);
}

/**
* function lbPlayerManialinkPageAnswer($event,$login,$answer)
* {
* 	if($answer == 100 ) multi_message(99,$login, 2);
* 	if($answer == 99) manialinksRemoveManialinkHook($login,'lb_ml');
* }
*/

function lbPlayerManialinkPageAnswer($event,$login,$answer,$action){
	global $_mldebug,$lb_ml_force, $lb_ml_page, $lb_maxpagecount;

	if($action=='lb_ml_mm.quit'){
		lb_ml_dsp($login,'remove');

	}elseif($action=='lb_ml_mm.next'){
			if($lb_ml_page[$login] < $lb_maxpagecount[$login])
				{$lb_ml_page[$login]++;}
				else{$lb_ml_page[$login] = 0;}
		lb_ml_dsp($login,'refresh');
	
	}elseif($action=='lb_ml_mm.prev'){
			if($lb_ml_page[$login] > 0)
				{$lb_ml_page[$login]--;}
				else{$lb_ml_page[$login] = $lb_maxpagecount[$login];}
		lb_ml_dsp($login,'refresh');
	}
}

/**
* function lb_ml_mm($login,&$pml){
* 	global $lb_msgs, $lb_ml_page;
* 	$xml = "<?xml version='1.0' encoding='utf-8' ?> 
* <manialink posx='0.5' posy='0.84'> 
*   <type>default</type> 
*   <format textsize='4'/> 
*   <background bgcolor='666d' bgborderx='0.03' bgbordery='0.03'/> 
*   <line height='1.0'><cell width='1.0'><text halign='center' textcolor='FF0F'><![CDATA[".$lb_msgs[$login][$lb_ml_page[$login]]."]]></text></cell></line> 
*   <line><cell height='0.04' width='1.0'><text halign='center' action='99' textcolor='F00F'>Close</text></cell></line>
*   <line><cell height='0.04' width='1.0'><text halign='center' action='100' textcolor='F00F'>Next</text></cell></line> 
* </manialink>";
* 	
*   return ($xml);

* }
*/

function lb_ml_dsp($login,$action){
	global $_mldebug, $_ml_act, $_players, $lb_msgs, $lb_ml_page;
	// if the players disabled manialinks then do nothing
	if(!isset($_players[$login]['ML']['ShowML']) || $_players[$login]['ML']['ShowML']<=0)
		return;

	if($action=='remove'){
		// remove manialink
		manialinksRemove($login,'lb_ml_mm');
		return;

	}elseif($action=='hide'){
		// hide manialink
		manialinksHide($login,'lb_ml_mm');
		return;

	}elseif($action=='refresh' && !manialinksIsOpened($login,'lb_ml_mm')){
		// refresh but not opened: do nothing
		return;
	}

	// show/refresh
	$xml = sprintf('<frame posn="0 -15 0">'
								 .'<quad  sizen="85 75" posn="0 20 0" halign="center"  valign="center" style="Bgs1" substyle="BgTitle2"/>'
								// .'<quad  sizen="57 5" posn="0 11 0.1" halign="center" valign="center" style="Bgs1" substyle="BgTitle2"/>'
								// .'<label sizen="50 3" posn="0 11 0.11" halign="center" valign="center" style="TextTitle2" text="'.$label.'"/>'
								 .'<label sizen="50 2" posn="0 56 0.1" halign="center" valign="top" style="TextRaceMessage" text="'
								 .$lb_msgs[$login][$lb_ml_page[$login]].'"/>'
								 .'<label posn="-2 -10 0.1" halign="right" style="CardButtonMedium" action="%d" text="Prev"/>'
								 .'<label posn="2 -10 0.1" halign="left" style="CardButtonMedium" action="%d" text="Next"/>'
								 .'<label posn="0 -6 0.1" halign="center" style="CardButtonSmall" action="%d" text="Close"/>'		 
								 .'</frame>',
								 $_ml_act['lb_ml_mm.prev'],$_ml_act['lb_ml_mm.next'],$_ml_act['lb_ml_mm.quit']);
	// show manialink
//	if($lb_ml_force)
//		manialinksShowForce($login,'lb_ml_mm',$xml);
//	else
		manialinksShow($login,'lb_ml_mm',$xml);
}

?>
